(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    117906,       2825]
NotebookOptionsPosition[    117406,       2803]
NotebookOutlinePosition[    117871,       2823]
CellTagsIndexPosition[    117828,       2820]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"<<", "\"\<Combinatorica`\>\""}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Check", " ", "pure", " ", "discreteness", " ", "of", " ", 
     RowBox[{"Kenyon", "'"}], "s", " ", "tilings", " ", "in", " ", "Section", 
     " ", "3.1", " ", "in", " ", "Akiyama"}], "-", 
    RowBox[{
    "Lee", " ", 
     "\"\<Determining pure discrete spectrum on some self-affine \
tilings\>\""}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tar", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "3", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "3", ",", "3"}], "}"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"We", " ", "skip", " ", "two", " ", "cases", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "1", ",", "2"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"3", ",", "0", ",", "3"}], "}"}]}], "}"}], " ", "which", " ", 
    "seems", " ", "beyond", " ", "our", " ", 
    RowBox[{"capability", "."}]}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, 3.476808312215228*^9, {3.476810467341508*^9, 
   3.4768104760936327`*^9}, {3.476810691504703*^9, 3.4768107070717382`*^9}, 
   3.4768555123946238`*^9, {3.476856014598378*^9, 3.476856027735775*^9}, {
   3.476858294946039*^9, 3.476858297204433*^9}, {3.476967859882217*^9, 
   3.4769678835877733`*^9}, {3.476968317190411*^9, 3.4769683258947353`*^9}, {
   3.476968447150278*^9, 3.476968447564068*^9}, {3.4769707738446293`*^9, 
   3.4769707996025553`*^9}, 3.477089304184712*^9, {3.477089963821226*^9, 
   3.477090023987135*^9}, {3.477090119050045*^9, 3.477090150368054*^9}, {
   3.47709020216897*^9, 3.477090206416108*^9}, {3.4770902591048403`*^9, 
   3.477090291608451*^9}, {3.477090399238679*^9, 3.477090465251609*^9}, {
   3.4770905501268*^9, 3.477090559661631*^9}, {3.477090612018401*^9, 
   3.477090735885434*^9}, {3.477090814553059*^9, 3.477090818916932*^9}, {
   3.477091001224908*^9, 3.477091084814866*^9}, {3.4770915902957363`*^9, 
   3.4770917606395617`*^9}, {3.4771095136716833`*^9, 
   3.4771095214669228`*^9}, {3.477109642794795*^9, 3.477109689490555*^9}, {
   3.477109895569553*^9, 3.477109908254321*^9}, {3.4771113552632513`*^9, 
   3.4771113610027857`*^9}, {3.477111641659432*^9, 3.4771116452024317`*^9}, {
   3.477111735749465*^9, 3.477111757266395*^9}, {3.4771119366418047`*^9, 
   3.477112016717514*^9}, {3.477112380315874*^9, 3.477112410808321*^9}, {
   3.4771137566718082`*^9, 3.4771137738259487`*^9}, {3.4771140040904207`*^9, 
   3.477114037301383*^9}, {3.4772071871075687`*^9, 3.477207220004415*^9}, {
   3.477289564549917*^9, 3.477289610557193*^9}, 3.477294766679288*^9, {
   3.477297485918042*^9, 3.477297488770396*^9}, {3.4772975609264727`*^9, 
   3.477297563300296*^9}, 3.477299646946447*^9, {3.477343808156139*^9, 
   3.477343832831038*^9}, {3.4773566355789127`*^9, 3.477356655495257*^9}, {
   3.4773566951549807`*^9, 3.4773566953531723`*^9}, {3.4773705155020237`*^9, 
   3.4773705411119957`*^9}, {3.477370924847599*^9, 3.4773709516025963`*^9}, {
   3.477371033964199*^9, 3.4773710604534903`*^9}, {3.4773711796014023`*^9, 
   3.477371182438929*^9}, {3.48904986450354*^9, 3.489049889428966*^9}, {
   3.489049941603251*^9, 3.489050042472748*^9}, {3.489050284993938*^9, 
   3.489050327353191*^9}, {3.491213296793497*^9, 3.491213305189838*^9}, {
   3.491213645808734*^9, 3.49121366069805*^9}, {3.4912145492716923`*^9, 
   3.491214570897148*^9}, {3.4912442922196913`*^9, 3.4912443061845617`*^9}, {
   3.4912443579896193`*^9, 3.491244367762442*^9}, 3.4912444916799917`*^9, 
   3.491244521822535*^9, {3.4912455458491793`*^9, 3.491245617642865*^9}, 
   3.491245741732451*^9, {3.491245811882277*^9, 3.49124584160415*^9}, 
   3.491246018658517*^9, {3.4912925336941433`*^9, 3.491292620725525*^9}, 
   3.491293153995351*^9, 3.491294217473037*^9, {3.4912942498592787`*^9, 
   3.491294278247426*^9}, {3.4912943261008387`*^9, 3.491294362483781*^9}, 
   3.49129508537778*^9, 3.491295289158585*^9, {3.492330661064749*^9, 
   3.492330736383788*^9}, {3.4923307996209784`*^9, 3.49233080318917*^9}, {
   3.492330874871058*^9, 3.49233089072013*^9}, {3.492330934324232*^9, 
   3.4923309672340527`*^9}, 3.492331012521749*^9, {3.49233106592599*^9, 
   3.492331068802354*^9}, {3.492331113733817*^9, 3.492331181378675*^9}, {
   3.492331214869282*^9, 3.49233124512429*^9}, {3.492331932698062*^9, 
   3.492331935466321*^9}, {3.4925487491519613`*^9, 3.4925487704575167`*^9}, {
   3.492636938393024*^9, 3.492636960295354*^9}, {3.503272193375*^9, 
   3.503272220359375*^9}, {3.50345087665625*^9, 3.50345088128125*^9}, {
   3.503450936328125*^9, 3.5034509630625*^9}, {3.522063818875*^9, 
   3.52206389971875*^9}, {3.52206395390625*^9, 3.522063969421875*^9}, {
   3.522064031703125*^9, 3.522064036140625*^9}, {3.522064076921875*^9, 
   3.52206428609375*^9}, {3.52206432203125*^9, 3.5220645635*^9}, {
   3.522064594859375*^9, 3.52206468378125*^9}, {3.5220647513125*^9, 
   3.5220647998125*^9}, 3.522065096921875*^9, {3.52209306265625*^9, 
   3.522093192453125*^9}, {3.522093258234375*^9, 3.522093342078125*^9}, {
   3.5220933878125*^9, 3.52209338978125*^9}, {3.52209342225*^9, 
   3.522093475140625*^9}, {3.52209351590625*^9, 3.5220935401875*^9}, {
   3.522093576140625*^9, 3.522093583078125*^9}, {3.52209361384375*^9, 
   3.522093621796875*^9}, {3.522093655484375*^9, 3.522093680609375*^9}, {
   3.524464762015625*^9, 3.524464805609375*^9}, {3.5244651205625*^9, 
   3.52446531090625*^9}, {3.524465352015625*^9, 3.524465373953125*^9}, {
   3.5244654085625*^9, 3.524465448296875*^9}, 3.524465503578125*^9, {
   3.524466109609375*^9, 3.5244661921875*^9}, {3.524466226125*^9, 
   3.52446625925*^9}, {3.524466290015625*^9, 3.524466295375*^9}, {
   3.524466326109375*^9, 3.52446636103125*^9}, {3.524466402171875*^9, 
   3.524466445828125*^9}, {3.524466508640625*^9, 3.524466526296875*^9}, {
   3.5244666850625*^9, 3.524466688765625*^9}, {3.524467361078125*^9, 
   3.524467366125*^9}, {3.5244674834375*^9, 3.52446748603125*^9}, {
   3.5244679335625*^9, 3.5244679428125*^9}, {3.5244758409375*^9, 
   3.524475958671875*^9}, 3.524476130125*^9, {3.524476288984375*^9, 
   3.524476301296875*^9}, {3.5244765595625*^9, 3.524476593203125*^9}, {
   3.5244767031875*^9, 3.524476730171875*^9}, {3.524477715734375*^9, 
   3.524477835546875*^9}, {3.524477880453125*^9, 3.52447788275*^9}, {
   3.524478042125*^9, 3.5244781141875*^9}, {3.524478184390625*^9, 
   3.524478189703125*^9}, {3.5244783058125*^9, 3.524478321015625*^9}, {
   3.524478483375*^9, 3.524478488515625*^9}, {3.524478535125*^9, 
   3.524478573*^9}, {3.52447862840625*^9, 3.52447864546875*^9}, {
   3.52447870403125*^9, 3.5244787206875*^9}, {3.524478754515625*^9, 
   3.524478841859375*^9}, {3.524478936828125*^9, 3.5244789535*^9}, 
   3.52447912040625*^9, {3.5244791965625*^9, 3.5244791993125*^9}, {
   3.524479896453125*^9, 3.524480072125*^9}, {3.52448259421875*^9, 
   3.524482603921875*^9}, {3.524508450328125*^9, 3.52450848040625*^9}, {
   3.5245085761875*^9, 3.524508592953125*^9}, 3.5324033818125*^9, {
   3.545013701484375*^9, 3.54501380325*^9}, {3.54508779928125*^9, 
   3.545087802578125*^9}, {3.575020030546875*^9, 3.575020054578125*^9}, {
   3.575020086390625*^9, 3.57502020446875*^9}, {3.5750702281666355`*^9, 
   3.575070228494236*^9}, {3.5750703231464024`*^9, 3.575070334986823*^9}, 
   3.60220801007154*^9, {3.6022080696216235`*^9, 3.602208100171666*^9}, {
   3.602208277581915*^9, 3.602208423252118*^9}, {3.6022085062622347`*^9, 
   3.6022085811023397`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "compat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Combinatorica Graph and Permutations functionality has \
been superseded by preloaded functionality. The package now being loaded may \
conflict with this. Please see the Compatibility Guide for details.\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{
  3.575070463577849*^9, {3.602208105381674*^9, 3.6022081245417004`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Kenyon", "'"}], "s", " ", "construction"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"Tile", "=", "1"}], ",", 
    RowBox[{"Tile", "<", 
     RowBox[{"Length", "[", "Tar", "]"}]}], ",", 
    RowBox[{"Tile", "++"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p", ",", "q", ",", "r"}], "}"}], "=", 
      RowBox[{"Tar", "[", 
       RowBox[{"[", 
        RowBox[{"-", "Tile"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Parameters : \>\"", ",", 
       RowBox[{"Tar", "[", 
        RowBox[{"[", "Tile", "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"x", "/.", 
       RowBox[{"NSolve", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"x", "^", "3"}], "-", 
           RowBox[{"p", " ", 
            RowBox[{"x", "^", "2"}]}], "+", 
           RowBox[{"q", " ", "x"}], "+", "r"}], "\[Equal]", "0"}], ",", "x"}],
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Q", "=", 
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"Drop", "[", 
        RowBox[{
         RowBox[{"Sort", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"AlgebraicNumber", "[", 
              RowBox[{
               RowBox[{"Root", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"#", "^", "3"}], "-", 
                   RowBox[{"p", " ", 
                    RowBox[{"#", "^", "2"}]}], "+", 
                   RowBox[{"q", "#"}], "+", "r"}], "&"}], ",", "i"}], "]"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"N", "[", 
              RowBox[{"Abs", "[", "#1", "]"}], "]"}], "<", 
             RowBox[{"N", "[", 
              RowBox[{"Abs", "[", "#2", "]"}], "]"}]}], "&"}]}], "]"}], ",", 
         "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Dm", "=", 
      RowBox[{"IdentityMatrix", "[", "3", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Dm", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}], "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Dm", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "1"}], "]"}], "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Dm", "[", 
       RowBox[{"[", 
        RowBox[{"3", ",", "1"}], "]"}], "]"}], "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Dm", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2"}], "]"}], "]"}], "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Dm", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}], "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"p", " ", 
            RowBox[{
             RowBox[{"Q", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}], "^", "2"}]}], "-", 
           RowBox[{"i", " ", 
            RowBox[{"Q", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "-", "r"}], ",", 
          RowBox[{
           RowBox[{"p", " ", 
            RowBox[{
             RowBox[{"Q", "[", 
              RowBox[{"[", 
               RowBox[{"2", ",", "2"}], "]"}], "]"}], "^", "2"}]}], "-", 
           RowBox[{"i", " ", 
            RowBox[{"Q", "[", 
             RowBox[{"[", 
              RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "-", "r"}]}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "q"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Dm", "[", 
       RowBox[{"[", 
        RowBox[{"3", ",", "2"}], "]"}], "]"}], "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"p", " ", 
            RowBox[{
             RowBox[{"Q", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}], "^", "2"}]}], "-", 
           "i"}], ",", 
          RowBox[{
           RowBox[{"p", " ", 
            RowBox[{
             RowBox[{"Q", "[", 
              RowBox[{"[", 
               RowBox[{"2", ",", "2"}], "]"}], "]"}], "^", "2"}]}], "-", 
           "i"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "r"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Dm", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "3"}], "]"}], "]"}], "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"p", " ", 
            RowBox[{
             RowBox[{"Q", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}], "^", "2"}]}], "-", 
           "i"}], ",", 
          RowBox[{
           RowBox[{"p", " ", 
            RowBox[{
             RowBox[{"Q", "[", 
              RowBox[{"[", 
               RowBox[{"2", ",", "2"}], "]"}], "]"}], "^", "2"}]}], "-", 
           "i"}]}], "}"}], " ", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "r"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Dm", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "3"}], "]"}], "]"}], "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"i", " ", 
           RowBox[{
            RowBox[{"Q", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1"}], "]"}], "]"}], "^", "2"}]}], ",", 
          RowBox[{"i", " ", 
           RowBox[{
            RowBox[{"Q", "[", 
             RowBox[{"[", 
              RowBox[{"2", ",", "2"}], "]"}], "]"}], "^", "2"}]}]}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"p", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Dm", "[", 
       RowBox[{"[", 
        RowBox[{"3", ",", "3"}], "]"}], "]"}], "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"P0", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"x", ",", 
           RowBox[{
            RowBox[{"Q", ".", "x"}], "+", "#"}]}], "]"}], "&"}], ",", "Dm", 
        ",", 
        RowBox[{"{", "3", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Set", " ", "parameters", " ", "and", " ", "check", " ", "fundamantal", 
       " ", "necessary", " ", "conditions"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"sz", "=", 
      RowBox[{"Length", "[", "Q", "]"}]}], ";", " ", 
     RowBox[{"(*", " ", 
      RowBox[{"Size", " ", "of", " ", "Expanding", " ", "Matrix"}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"dg", "=", 
      RowBox[{"Length", "[", "P0", "]"}]}], ";", " ", 
     RowBox[{"(*", " ", 
      RowBox[{"Size", " ", "of", " ", "Substitution", " ", "Matrix"}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"A1", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Map", "[", 
        RowBox[{"Length", ",", "P0", ",", 
         RowBox[{"{", "2", "}"}]}], "]"}], "]"}]}], ";", "\n", 
     RowBox[{"Eg", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{
        RowBox[{"Eigenvalues", "[", "A1", "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{"Abs", "[", "#1", "]"}], "]"}], "<", 
          RowBox[{"N", "[", 
           RowBox[{"Abs", "[", "#2", "]"}], "]"}]}], "&"}]}], "]"}]}], ";", 
     "\n", 
     RowBox[{"PF", "=", 
      RowBox[{"Abs", "[", 
       RowBox[{"Last", "[", "Eg", "]"}], "]"}]}], ";", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Find", " ", "the", " ", "polynomial", " ", "which", " ", "corresponds",
        " ", "to", " ", "the", " ", "Perron", " ", "Frobenius", " ", "root"}],
       "*)"}], "\n", 
     RowBox[{"Flist", "=", 
      RowBox[{"Map", "[", 
       RowBox[{"First", ",", 
        RowBox[{"FactorList", "[", 
         RowBox[{"CharacteristicPolynomial", "[", 
          RowBox[{"A1", ",", "x"}], "]"}], "]"}]}], "]"}]}], ";", "\n", 
     RowBox[{"Flist", "=", 
      RowBox[{"Delete", "[", 
       RowBox[{"Flist", ",", 
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{"NumberQ", ",", "Flist"}], "]"}], ",", "True"}], "]"}]}], 
       "]"}]}], ";", "\n", 
     RowBox[{"FlistSol", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Max", "[", 
          RowBox[{"Abs", "[", "#", "]"}], "]"}], "&"}], ",", 
        RowBox[{"x", "/.", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"z", ",", 
             RowBox[{"NSolve", "[", 
              RowBox[{"z", ",", "x"}], "]"}]}], "]"}], ",", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "\[Equal]", "0"}], "&"}], ",", "Flist"}], "]"}]}], 
          "]"}]}]}], "]"}]}], ";", "\n", 
     RowBox[{"Fd", "=", 
      RowBox[{"First", "[", 
       RowBox[{"Extract", "[", 
        RowBox[{"Flist", ",", 
         RowBox[{"Position", "[", 
          RowBox[{"FlistSol", ",", 
           RowBox[{"Max", "[", "FlistSol", "]"}]}], "]"}]}], "]"}], "]"}]}], 
     ";", "\[IndentingNewLine]", "\n", 
     RowBox[{"Print", "[", 
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"Graphics", "[", 
         RowBox[{"Circle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"Map", "[", 
         RowBox[{"Graphics", ",", 
          RowBox[{"Map", "[", 
           RowBox[{"Point", ",", 
            RowBox[{"FullSimplify", "[", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Re", "[", "#", "]"}], ",", 
                  RowBox[{"Im", "[", "#", "]"}]}], "}"}], "&"}], ",", "Eg"}], 
              "]"}], "]"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Eg0", "=", 
      RowBox[{
       RowBox[{"Sort", "[", 
        RowBox[{
         RowBox[{"x", "/.", 
          RowBox[{"NSolve", "[", 
           RowBox[{
            RowBox[{"Fd", "\[Equal]", "0"}], ",", "x"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"Abs", "[", "#1", "]"}], "]"}], "<", 
           RowBox[{"N", "[", 
            RowBox[{"Abs", "[", "#2", "]"}], "]"}]}], "&"}]}], "]"}], 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Or", "[", 
          RowBox[{
           RowBox[{"PF", "\[LessEqual]", "1"}], ",", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"Det", "[", 
                RowBox[{"Q", "//", "N"}], "]"}], "]"}], "-", "PF"}], "]"}], ">=", 
            RowBox[{"1000", "$MachineEpsilon"}]}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
          "Print", "[", "\"\<Lagarias-Wang PF conditition : No\>\"", "]"}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"Interrupt", "[", "]"}]}], ",", 
         RowBox[{
         "Print", "[", "\"\<Lagarias-Wang PF conditition : fulfiled\>\"", 
          "]"}]}], "]"}]}]}], ";", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{"Check", " ", "Pisot", " ", "Family", " ", 
       RowBox[{"condition", " ", ":", " ", 
        RowBox[{"Higher", " ", "Version"}]}]}], "  ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"EigenQ", "=", 
      RowBox[{"Eigenvalues", "[", "Q", "]"}]}], ";", "\n", 
     RowBox[{"EigenQ", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{"Function", "[", 
         RowBox[{"z", ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"NumberQ", "[", "z", "]"}], ",", "z", ",", 
            RowBox[{"AlgebraicNumber", "[", 
             RowBox[{
              RowBox[{"Root", "[", 
               RowBox[{
                RowBox[{"MinimalPolynomial", "[", "z", "]"}], ",", 
                RowBox[{"First", "[", 
                 RowBox[{"First", "[", 
                  RowBox[{"Position", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"z", "-", 
                    RowBox[{"AlgebraicNumber", "[", 
                    RowBox[{
                    RowBox[{"Root", "[", 
                    RowBox[{
                    RowBox[{"MinimalPolynomial", "[", "z", "]"}], ",", "i"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ")"}], "//", 
                    "N"}], "]"}], "<", 
                    RowBox[{"1000", "*", "$MachineEpsilon"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"CoefficientList", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MinimalPolynomial", "[", "z", "]"}], "[", "x", 
                    "]"}], ",", "x"}], "]"}], "]"}], "-", "1"}]}], "}"}]}], 
                    "]"}], ",", "True"}], "]"}], "]"}], "]"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], "]"}]}], "]"}], ",",
         "\[IndentingNewLine]", "EigenQ"}], "]"}]}], ";", "\n", 
     RowBox[{"AlgSol", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "EigenQ", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"NumberQ", "[", 
          RowBox[{"EigenQ", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
         RowBox[{"AlgSol", "=", 
          RowBox[{"Union", "[", 
           RowBox[{"AlgSol", ",", 
            RowBox[{"{", 
             RowBox[{"EigenQ", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "}"}]}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"AlgSol", "=", 
          RowBox[{"Union", "[", 
           RowBox[{"AlgSol", ",", 
            RowBox[{"Map", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"AlgebraicNumber", "[", 
                RowBox[{
                 RowBox[{"Root", "[", 
                  RowBox[{
                   RowBox[{"MinimalPolynomial", "[", 
                    RowBox[{"First", "[", 
                    RowBox[{"EigenQ", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", "#"}], 
                  "]"}], ",", 
                 RowBox[{"EigenQ", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "]"}], "&"}], ",", 
              RowBox[{"Range", "[", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{
                  RowBox[{"EigenQ", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}], "-", "1"}], "]"}]}], 
             "]"}]}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"AlgSol", "=", 
      RowBox[{"Extract", "[", 
       RowBox[{"AlgSol", ",", 
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"AlgSol", "//", "N"}], ",", 
          RowBox[{"x_", "/;", 
           RowBox[{
            RowBox[{"Abs", "[", "x", "]"}], ">", "1"}]}]}], "]"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Complement", "[", 
         RowBox[{"AlgSol", ",", "EigenQ"}], "]"}], "\[Equal]", 
        RowBox[{"{", "}"}]}], ",", " ", "\[IndentingNewLine]", 
       RowBox[{
       "Print", "[", "\"\<Pisot family condition : fulfiled\>\"", "]"}], ",", 
       " ", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Pisot family condition : No\>\"", "]"}], 
        ";", 
        RowBox[{"Interrupt", "[", "]"}], ";"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"Side", " ", "information", " ", "for", " ", "1"}], "-", 
       RowBox[{"dim", " ", "case"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "Eg0", "]"}], "<", 
        RowBox[{"Length", "[", "Eg", "]"}]}], ",", 
       RowBox[{
       "Print", "[", "\"\<Reducible characteristic polynomial\>\"", "]"}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "Eg0", "]"}], "\[Equal]", "1"}], "||", 
        RowBox[{"1", ">", 
         RowBox[{"Max", "[", 
          RowBox[{"Abs", "[", 
           RowBox[{"Drop", "[", 
            RowBox[{"Eg0", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}], "]"}]}]}], ",", 
       RowBox[{"Print", "[", "\"\<Dominant root : Pisot\>\"", "]"}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Dominant root : Non Pisot\>\"", "]"}], 
        ";"}]}], "]"}], ";", "\n", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Diameter", "[", 
         RowBox[{"FromAdjacencyMatrix", "[", 
          RowBox[{"A1", ",", 
           RowBox[{"Type", "\[Rule]", "Directed"}]}], "]"}], "]"}], 
        "\[Equal]", "\[Infinity]"}], ",", 
       RowBox[{
        RowBox[{
        "Print", "[", "\"\<Substitution rule: Not irreducible\>\"", "]"}], 
        ";", 
        RowBox[{"Interrupt", "[", "]"}], ";"}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Substitution rule: Irreducible\>\"", "]"}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"Eg", "[", 
               RowBox[{"[", 
                RowBox[{"-", "1"}], "]"}], "]"}], "]"}], "-", 
             RowBox[{"Abs", "[", 
              RowBox[{"Eg", "[", 
               RowBox[{"[", 
                RowBox[{"-", "2"}], "]"}], "]"}], "]"}]}], "]"}], "<", 
           RowBox[{"100", "*", "$MachineEpsilon"}]}], ",", 
          RowBox[{
           RowBox[{
           "Print", "[", "\"\<Substitution rule: Not primitive\>\"", "]"}], 
           ";", 
           RowBox[{"Interrupt", "[", "]"}], ";"}], ",", 
          RowBox[{
          "Print", "[", "\"\<Substitution rule: Primitive\>\"", "]"}]}], 
         "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Choose", " ", "FixPoints", " ", "of", " ", "tiles", " ", "close", " ", 
       "to", " ", "their", " ", "centroids"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"P0inv", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{"Function", "[", 
         RowBox[{"z", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Inverse", "[", "Q", "]"}], ".", 
            RowBox[{"(", 
             RowBox[{"z", "+", "#"}], ")"}]}], "&"}]}], "]"}], ",", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Apply", "[", 
            RowBox[{"#", ",", 
             RowBox[{"{", 
              RowBox[{"Table", "[", 
               RowBox[{"0", ",", 
                RowBox[{"{", "sz", "}"}]}], "]"}], "}"}]}], "]"}], "&"}], ",",
           "P0", ",", 
          RowBox[{"{", "3", "}"}]}], "]"}], ",", 
        RowBox[{"{", "3", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Phinv", "=", "P0inv"}], ";", "\n", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Fold", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#1", "&&", "#2"}], "&"}], ",", "True", ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"Phinv", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "i"}], "]"}], "]"}], "]"}], ">", "50"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "Phinv", "]"}]}], "}"}]}], "]"}]}], 
         "]"}], "\[Equal]", "False"}], ",", 
       RowBox[{
        RowBox[{"Qh", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Flatten", "[", 
               RowBox[{"Outer", "[", 
                RowBox[{"Composition", ",", 
                 RowBox[{"P0inv", "[", 
                  RowBox[{"[", 
                   RowBox[{"j", ",", "k"}], "]"}], "]"}], ",", 
                 RowBox[{"Phinv", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", "1"}], "]"}], 
               "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "1", ",", "dg"}], "}"}]}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "dg"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], ";", "\n", 
        RowBox[{"Phinv", "=", "Qh"}]}]}], "]"}], ";", 
     RowBox[{"(*", 
      RowBox[{"Anti", "-", 
       RowBox[{
       "product", " ", "of", " ", "the", " ", "matrix", " ", "is", " ", 
        "used"}]}], "*)"}], "\n", 
     RowBox[{"xy", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"x", "[", "j", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", "sz"}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{"FixPt0", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"xy", "/.", 
              RowBox[{"Solve", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", "xy", "]"}], "\[Equal]", "xy"}], ",", 
                "xy"}], "]"}]}], "&"}], ",", 
            RowBox[{"Phinv", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "i"}], "]"}], "]"}]}], "]"}], ",", "1"}], 
         "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{"CentFix", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{"Function", "[", 
         RowBox[{"z", ",", 
          RowBox[{
           RowBox[{"Fold", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#1", "+", "#2"}], "&"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{"0", ",", 
               RowBox[{"{", "sz", "}"}]}], "]"}], ",", "z"}], "]"}], "/", 
           RowBox[{"Length", "[", "z", "]"}]}]}], "]"}], ",", "FixPt0"}], 
       "]"}]}], ";", "\n", 
     RowBox[{"FixPt", "=", 
      RowBox[{"{", "}"}]}], ";", "\n", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "FixPt0", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TransFix", "=", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Norm", "[", 
             RowBox[{
              RowBox[{"N", "[", "#", "]"}], ",", "2"}], "]"}], "&"}], ",", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "-", 
               RowBox[{"CentFix", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "&"}], ",", 
             RowBox[{"FixPt0", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FixPt", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"FixPt", ",", 
           RowBox[{"Extract", "[", 
            RowBox[{
             RowBox[{"FixPt0", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"First", "[", 
               RowBox[{"Position", "[", 
                RowBox[{"TransFix", ",", 
                 RowBox[{"Min", "[", "TransFix", "]"}]}], "]"}], "]"}], 
              "}"}]}], "]"}]}], "\[IndentingNewLine]", "]"}]}]}]}], "]"}], 
     ";", "\n", 
     RowBox[{"FixPt", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"FixPt", ",", "1"}], "]"}]}], ";", "\n", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Translate", " ", 
       RowBox[{"digits", ":", 
        RowBox[{
        "so", " ", "that", " ", "all", " ", "tiles", " ", "contain", " ", 
         "the", " ", "origin", " ", "as", " ", "a", " ", "fix", " ", 
         "point"}]}]}], "*)"}], "\n", 
     RowBox[{"DigMat", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Apply", "[", 
          RowBox[{"#", ",", 
           RowBox[{"{", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", "sz", "}"}]}], "]"}], "}"}]}], "]"}], "&"}], ",", 
        "P0", ",", 
        RowBox[{"{", "3", "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{"DigMat2", "=", 
      RowBox[{"IdentityMatrix", "[", 
       RowBox[{"Length", "[", "DigMat", "]"}], "]"}]}], ";", "\n", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "DigMat", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"j", "=", "1"}], ",", 
         RowBox[{"j", "\[LessEqual]", 
          RowBox[{"Length", "[", "DigMat", "]"}]}], ",", 
         RowBox[{"j", "++"}], ",", 
         RowBox[{
          RowBox[{"DigMat2", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "j"}], "]"}], "]"}], "=", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Function", "[", 
             RowBox[{"z", ",", 
              RowBox[{"z", "-", 
               RowBox[{"Q", ".", 
                RowBox[{"FixPt", "[", 
                 RowBox[{"[", "j", "]"}], "]"}]}], "+", 
               RowBox[{"FixPt", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}]}], "]"}], ",", 
            RowBox[{"DigMat", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "j"}], "]"}], "]"}]}], "]"}]}]}], "]"}]}], 
      "]"}], ";", "\n", 
     RowBox[{"P0", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{"Function", "[", 
         RowBox[{"z", ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Q", ".", "#"}], "+", "z"}], ")"}], "&"}]}], "]"}], ",", 
        "DigMat2", ",", 
        RowBox[{"{", "3", "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{"P0inv", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{"Function", "[", 
         RowBox[{"z", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Inverse", "[", "Q", "]"}], ".", 
            RowBox[{"(", 
             RowBox[{"#", "+", "z"}], ")"}]}], "&"}]}], "]"}], ",", "DigMat2",
         ",", 
        RowBox[{"{", "3", "}"}]}], "]"}]}], ";", "\n", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
        RowBox[{
        "Choose", " ", "an", " ", "initial", " ", "fix", " ", "point", " ", 
         "for", " ", "Delone", " ", 
         RowBox[{"set", ".", " ", "#"}], " ", "of", " ", "power", " ", "of", 
         " ", 
         RowBox[{"Q", "^", "kp"}], " ", "must", " ", "satisfy", " ", 
         RowBox[{"Norm", "[", 
          RowBox[{
           RowBox[{"Q", "^", 
            RowBox[{"{", 
             RowBox[{"-", "kp"}], "}"}]}], ",", "2"}], "]"}]}], " ", "<", " ", 
        RowBox[{
        "Ratio", " ", "\[IndentingNewLine]", "with", " ", "Ratio", " ", "1.", 
         " ", "The", " ", "choice", " ", "of", " ", "Ratio", " ", "is", " ", 
         RowBox[{"subtle", ".", " ", "To"}], " ", "have", " ", "a", " ", 
         "better", " ", "bound", " ", "defining", " ", "potential", " ", 
         "overlap"}]}], ",", " ", 
       RowBox[{"choose", " ", "smaller", " ", 
        RowBox[{"Ratio", ".", " ", "However"}], " ", "as", " ", "kp", " ", 
        "increases"}], ",", " ", 
       RowBox[{
       "the", " ", "later", " ", "computational", " ", "size", " ", "becomes",
         " ", 
        RowBox[{"large", "."}]}]}], " ", "*)"}], "\n", 
     RowBox[{"kp", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"Better", " ", "to", " ", "take", " ", "Ratio"}], "=", 
       RowBox[{
        RowBox[{"1", "/", "2"}], " ", "when", " ", "dimension", " ", "is", 
        " ", "not", " ", "greater", " ", "than", " ", "2"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"sz", ">", "2"}], ",", 
       RowBox[{"Ratio", "=", "1"}], ",", 
       RowBox[{"Ratio", "=", 
        RowBox[{"1", "/", "2"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"rho", "=", "\[Infinity]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"MinPow", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"rho", "=", 
          RowBox[{"Norm", "[", 
           RowBox[{
            RowBox[{"MatrixPower", "[", 
             RowBox[{
              RowBox[{"Q", "//", "N"}], ",", 
              RowBox[{"-", "MinPow"}]}], "]"}], ",", "2"}], "]"}]}], ")"}], 
        "\[GreaterEqual]", "Ratio"}], ",", 
       RowBox[{"MinPow", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Ph", "=", "P0"}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Fold", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"#1", "&&", "#2"}], "&"}], ",", "True", ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Ph", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "i"}], "]"}], "]"}], "==", 
              RowBox[{"{", "}"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "[", "Ph", "]"}]}], "}"}]}], "]"}]}], "]"}], 
         "\[Equal]", "True"}], " ", "||", "  ", 
        RowBox[{"kp", "<", "MinPow"}]}], ",", 
       RowBox[{
        RowBox[{"Qh", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Flatten", "[", 
               RowBox[{"Outer", "[", 
                RowBox[{"Composition", ",", 
                 RowBox[{"Ph", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
                 RowBox[{"P0", "[", 
                  RowBox[{"[", 
                   RowBox[{"j", ",", "k"}], "]"}], "]"}], ",", "1"}], "]"}], 
               "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "1", ",", "dg"}], "}"}]}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "dg"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Ph", "=", "Qh"}], ";", 
        RowBox[{"kp", "++"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
     "\n", 
     RowBox[{"P", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Length", "[", "P0", "]"}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Choose", " ", "an", " ", "initial", " ", "point", " ", "in", " ", 
       "Lambda_col"}], "*)"}], "\n", 
     RowBox[{"col", "=", 
      RowBox[{"First", "[", 
       RowBox[{"First", "[", 
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{"Length", ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Ph", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "i"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], "]"}], 
          ",", 
          RowBox[{"Max", "[", 
           RowBox[{"Map", "[", 
            RowBox[{"Length", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Ph", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "i"}], "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], "]"}], 
           "]"}]}], "]"}], "]"}], "]"}]}], ";", "\n", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<Color \>\"", ",", " ", "col", ",", " ", 
       "\"\< Delone set is used.\>\""}], "]"}], ";", " ", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"P", "[", 
       RowBox[{"[", "col", "]"}], "]"}], "=", 
      RowBox[{"xy", "/.", 
       RowBox[{"Solve", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"First", "[", 
           RowBox[{"Ph", "[", 
            RowBox[{"[", 
             RowBox[{"col", ",", "col"}], "]"}], "]"}], "]"}], "[", "xy", 
          "]"}], "\[Equal]", "xy"}], "]"}]}]}], ";", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"If", " ", "the", " ", "data", " ", "is", " ", "complex"}], 
       ",", " ", 
       RowBox[{"'", 
        RowBox[{"Lat", "'"}], " ", "transfers", " ", "it", " ", "to", " ", 
        "real", " ", 
        RowBox[{"vectors", ".", " ", "Note"}], " ", "that", " ", "when", " ", 
        "Q", " ", "is", " ", "a", " ", "diagonal", " ", "matrix", " ", "and", 
        " ", "some", " ", "entry", " ", "of", " ", "Q", " ", "is", " ", 
        "complex"}], ",", " ", 
       RowBox[{
       "a", " ", "2", " ", "by", " ", "2", " ", "block", " ", "on", " ", 
        "the", " ", "diagonal", " ", "of", " ", "Q", " ", "consists", " ", 
        "of", " ", "complex", " ", "conjugates", " ", "in", " ", "pairs"}]}], 
      " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Lat", "=", 
      RowBox[{"Function", "[", 
       RowBox[{"z", ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"Im", "[", 
               RowBox[{"N", "[", 
                RowBox[{"Q", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "i"}], "]"}], "]"}], "]"}], "]"}], "]"}], 
             ">", 
             RowBox[{"100", "$MachineEpsilon"}]}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"OddQ", "[", "i", "]"}], ",", 
              RowBox[{"Re", "[", 
               RowBox[{"N", "[", 
                RowBox[{"z", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
              RowBox[{"Im", "[", 
               RowBox[{"N", "[", 
                RowBox[{"z", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", "-", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
             "]"}], ",", 
            RowBox[{"z", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "z", "]"}]}], "}"}]}], "]"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Prepare", " ", "full", " ", "rank", " ", "return", " ", "vectors"}], 
      " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"w0", "=", "P"}], ";", "\[IndentingNewLine]", 
     RowBox[{"w", "=", 
      RowBox[{"First", "[", 
       RowBox[{"P", "[", 
        RowBox[{"[", "col", "]"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"L1", "=", 
      RowBox[{"{", 
       RowBox[{"{", "0", "}"}], "}"}]}], ";", "\n", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"MatrixRank", "[", "L1", "]"}], "<", "sz"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"w0", "=", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"z", ",", 
             RowBox[{"Apply", "[", 
              RowBox[{
               RowBox[{"z", "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"z", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"j", ",", "2", ",", 
                    RowBox[{"sz", "+", "1"}]}], "}"}]}], "]"}], "}"}]}], 
              "]"}]}], "]"}], ",", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Partition", "[", 
               RowBox[{"#", ",", 
                RowBox[{"sz", "+", "1"}]}], "]"}], "&"}], ",", 
             RowBox[{"Map", "[", 
              RowBox[{"Flatten", ",", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{"Outer", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"Ph", "[", 
                    RowBox[{"[", 
                    RowBox[{"j", ",", "i"}], "]"}], "]"}], ",", 
                    RowBox[{"w0", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}], ",", 
                    "2"}], "]"}], ",", "2"}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"j", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], "]"}],
              ",", "1"}], "]"}], ",", 
           RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"L1", "=", 
         RowBox[{"Sort", "[", 
          RowBox[{
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{"Function", "[", 
              RowBox[{"z", ",", 
               RowBox[{"z", "-", "w"}]}], "]"}], ",", 
             RowBox[{"w0", "[", 
              RowBox[{"[", "col", "]"}], "]"}], ",", "1"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"Norm", "[", 
              RowBox[{
               RowBox[{"N", "[", "#1", "]"}], ",", "2"}], "]"}], "<", 
             RowBox[{"Norm", "[", 
              RowBox[{
               RowBox[{"N", "[", "#2", "]"}], ",", "2"}], "]"}]}], "&"}]}], 
          "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\n", 
     RowBox[{"j", "=", "0"}], ";", "\n", 
     RowBox[{"rt1", "=", 
      RowBox[{"{", "}"}]}], ";", "\n", 
     RowBox[{"i", "=", "1"}], ";", "\n", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{"j", "<", "sz"}], ",", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"MatrixRank", "[", 
            RowBox[{"Take", "[", 
             RowBox[{"L1", ",", "i"}], "]"}], "]"}], ">", "j"}], ",", 
          RowBox[{
           RowBox[{"rt1", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"rt1", ",", 
              RowBox[{"L1", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], ";", 
           RowBox[{"j", "=", 
            RowBox[{"MatrixRank", "[", 
             RowBox[{"Take", "[", 
              RowBox[{"L1", ",", "i"}], "]"}], "]"}]}]}]}], "]"}], ";", 
        RowBox[{"i", "++"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<Return vectors of \>\"", ",", "w", ",", "\"\< is \>\"", ",", 
       "rt1"}], "]"}], ";", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{"Return", " ", "vector", " ", "length"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"al", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Norm", "[", 
          RowBox[{
           RowBox[{"Lat", "[", "#", "]"}], ",", "2"}], "]"}], "&"}], ",", 
        RowBox[{"rt1", "//", "N"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Geometric", " ", "Substitution", " ", "Data"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"Rl0", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"P0dig", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Apply", "[", 
          RowBox[{"#", ",", 
           RowBox[{"{", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", "sz", "}"}]}], "]"}], "}"}]}], "]"}], "&"}], ",", 
        "P0", ",", 
        RowBox[{"{", "3", "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "1"}], ",", 
       RowBox[{"j", "\[LessEqual]", "dg"}], ",", 
       RowBox[{"j", "++"}], ",", 
       RowBox[{
        RowBox[{"Tes", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", "dg"}], ",", 
          RowBox[{"i", "++"}], ",", 
          RowBox[{"Tes", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"Tes", ",", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{"Function", "[", 
                RowBox[{"z", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"i", "-", "1"}], ",", "z"}], "}"}]}], "]"}], ",", 
               RowBox[{"P0dig", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "j"}], "]"}], "]"}]}], "]"}]}], "]"}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Rl0", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"Rl0", ",", 
           RowBox[{"Flatten", "[", 
            RowBox[{"Tes", ",", "1"}], "]"}]}], "]"}]}], ";"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Geometric", " ", "substitution"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"Gsbst", "=", 
      RowBox[{"Function", "[", 
       RowBox[{"z", ",", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "+", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"Q", ".", 
               RowBox[{"Last", "[", "z", "]"}]}]}], "}"}]}], "&"}], ",", 
          RowBox[{"Rl0", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"First", "[", "z", "]"}], "+", "1"}], "]"}], "]"}]}], 
         "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Gs", "=", 
      RowBox[{"Function", "[", 
       RowBox[{"z", ",", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{"Gsbst", ",", "z"}], "]"}], ",", "1"}], "]"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Initial", " ", "Ov", " ", "should", " ", "not", " ", "be", " ", 
       "empty"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"rp", "=", "0"}], ";", "\[IndentingNewLine]", 
     RowBox[{"St1", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"z", ",", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"z", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", "#"}], "}"}], "&"}], 
              ",", 
              RowBox[{"Last", "[", "z", "]"}]}], "]"}]}], "]"}], ",", 
          RowBox[{"MapThread", "[", 
           RowBox[{"List", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Range", "[", 
                RowBox[{"Length", "[", "P", "]"}], "]"}], "-", "1"}], ",", 
              "P"}], "}"}]}], "]"}]}], "]"}], ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Compute", " ", "the", " ", "period", " ", "of", " ", "the", " ", 
       "starting", " ", "point", " ", "by", " ", 
       RowBox[{"substitution", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Period", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Complement", "[", 
         RowBox[{"St1", ",", 
          RowBox[{"Nest", "[", 
           RowBox[{"Gs", ",", "St1", ",", "Period"}], "]"}]}], "]"}], "=!=", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"Period", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Compute", " ", "block", " ", 
       RowBox[{"digits", " ", "\\", "sum"}], " ", 
       RowBox[{"Q", "^", 
        RowBox[{"{", 
         RowBox[{"-", "n"}], "}"}]}], " ", "D_", 
       RowBox[{"{", "ij", "}"}], " ", "of", " ", "length", " ", "Period", " ", 
       RowBox[{"Ceiling", "[", 
        RowBox[{"MinPow", "/", "Period"}], "]"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"Ph0", "=", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{"FixPt", ",", "1"}], "]"}], "*", "0"}]}], ";", "\n", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"Ph0", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"z", ",", 
            RowBox[{"Apply", "[", 
             RowBox[{
              RowBox[{"z", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"z", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"j", ",", "2", ",", 
                   RowBox[{"sz", "+", "1"}]}], "}"}]}], "]"}], "}"}]}], 
             "]"}]}], "]"}], ",", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{"#", ",", 
               RowBox[{"sz", "+", "1"}]}], "]"}], "&"}], ",", 
            RowBox[{"Map", "[", 
             RowBox[{"Flatten", ",", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Partition", "[", 
                   RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{"Outer", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"P0inv", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
                    RowBox[{"Ph0", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}], ",", 
                    "2"}], "]"}], ",", "2"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"j", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], "]"}], 
            ",", "1"}], "]"}], ",", 
          RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"Period", " ", 
         RowBox[{"Ceiling", "[", 
          RowBox[{"MinPow", "/", "Period"}], "]"}]}], "}"}]}], "]"}], ";", 
     "\n", "\[IndentingNewLine]", " ", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "Compute", " ", "an", " ", "upper", " ", "bound", " ", "of", " ", 
        "difference", " ", "of", " ", "two", " ", "tiles", " ", "T_i"}], "-", 
       "T_j"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Dig", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"MatrixPower", "[", 
           RowBox[{"Q", ",", 
            RowBox[{"Period", " ", 
             RowBox[{"Ceiling", "[", 
              RowBox[{"MinPow", "/", "Period"}], "]"}]}]}], "]"}], ".", "#"}],
          "&"}], ",", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Ph0", ",", "1"}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Dig2", "=", 
      RowBox[{
       RowBox[{"Union", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Outer", "[", 
           RowBox[{"Subtract", ",", "Dig", ",", "Dig", ",", "1"}], "]"}], ",",
           "1"}], "]"}], "]"}], "//", "N"}]}], ";", "\n", 
     RowBox[{"rho", "=", 
      RowBox[{"Norm", "[", 
       RowBox[{
        RowBox[{"MatrixPower", "[", 
         RowBox[{
          RowBox[{"Q", "//", "N"}], ",", 
          RowBox[{
           RowBox[{"-", "Period"}], " ", 
           RowBox[{"Ceiling", "[", 
            RowBox[{"MinPow", "/", "Period"}], "]"}]}]}], "]"}], ",", "2"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"diam", "=", 
      RowBox[{
       RowBox[{"Max", "[", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Norm", "[", 
            RowBox[{"#", ",", "2"}], "]"}], "&"}], ",", 
          RowBox[{"Map", "[", 
           RowBox[{"Lat", ",", "Dig2"}], "]"}]}], "]"}], "]"}], 
       RowBox[{"rho", "/", 
        RowBox[{"(", 
         RowBox[{"1", "-", "rho"}], ")"}]}]}]}], ";", "\n", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<Upper Bound of difference of two tiles = \>\"", ",", "diam"}], 
      "]"}], ";", "\n", 
     RowBox[{"Rdm", "=", 
      RowBox[{"diam", "+", 
       RowBox[{"rho", " ", 
        RowBox[{"Max", "[", "al", "]"}]}]}]}], ";", " ", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Constant", " ", "for", " ", "Potential", " ", "overlap", " ", 
       "computation"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"Set", " ", "initial", " ", "overlaps"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"OvTwo", "=", 
      RowBox[{"{", "\[Infinity]", "}"}]}], ";", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "Execute", " ", "the", " ", "procedure", " ", "for", " ", "Lemma", " ",
         "3.5", " ", "by", " ", "comparing", " ", "n", " ", "and", " ", "n"}],
        "+", 
       RowBox[{"k", " ", "step", " ", 
        RowBox[{"iterations", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Collect", " ", "initial", " ", "overlaps", " ", "by", " ", "embedding",
        " ", "Delone", " ", "set", " ", "into", " ", "a", " ", "suitable", 
       " ", "lattice"}], " ", "*)"}], "\n", 
     RowBox[{"OvTwo", "=", 
      RowBox[{"{", "\[Infinity]", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Ov0", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"OvHistory", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ss0", "=", 
      RowBox[{"SessionTime", "[", "]"}]}], ";", "\n", 
     RowBox[{"Mes", "=", "diam"}], ";", "\[IndentingNewLine]", 
     RowBox[{"StA", "=", 
      RowBox[{"Union", "[", 
       RowBox[{"Nest", "[", 
        RowBox[{"Gs", ",", "St1", ",", 
         RowBox[{"Period", " ", 
          RowBox[{"Ceiling", "[", 
           RowBox[{"MinPow", "/", "Period"}], "]"}]}]}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"StB", "=", "St1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "OvTwo", "]"}], "=!=", 
        RowBox[{"Length", "[", "Ov0", "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"StA", "=", 
         RowBox[{"Union", "[", 
          RowBox[{"Nest", "[", 
           RowBox[{"Gs", ",", "StA", ",", "Period"}], "]"}], "]"}]}], ";", 
        "\n", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Find", " ", "a", " ", "mesh", " ", "lattice", " ", "and", " ", 
          "embed", " ", "Delone", " ", "set", " ", "into", " ", "the", " ", 
          "lattice"}], " ", "*)"}], "\n", 
        RowBox[{"While", "[", 
         RowBox[{"True", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"StLat", "=", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Function", "[", 
               RowBox[{"z", ",", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{"Lat", "[", 
                   RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "/", "Mes"}], 
                 "]"}]}], "]"}], ",", "StA"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", "StLat", "]"}], "==", 
              RowBox[{"Length", "[", 
               RowBox[{"Union", "[", "StLat", "]"}], "]"}]}], ",", 
             RowBox[{"Break", "[", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Mes", "=", 
            RowBox[{"Mes", "/", 
             RowBox[{"2", "^", 
              RowBox[{"(", 
               RowBox[{"1", "/", 
                RowBox[{"(", 
                 RowBox[{"20", " ", "sz"}], ")"}]}], ")"}]}]}]}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"StLat2", "=", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"z", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{"1", ",", 
                  RowBox[{"{", "sz", "}"}]}], "]"}], "-", 
                RowBox[{"Map", "[", 
                 RowBox[{"Min", ",", 
                  RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}], "+", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{"Lat", "[", 
                   RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "/", "Mes"}], 
                 "]"}]}], ",", "z"}], "}"}]}], "]"}], ",", "StA"}], "]"}]}], 
        ";", "\n", 
        RowBox[{"StM", "=", 
         RowBox[{"Apply", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", "##"}], "]"}], "&"}], ",", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{"1", ",", 
                RowBox[{"{", "sz", "}"}]}], "]"}], "+", 
              RowBox[{"Map", "[", 
               RowBox[{"Max", ",", 
                RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}], "-", 
              RowBox[{"Map", "[", 
               RowBox[{"Min", ",", 
                RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}]}], ",", 
             "1"}], "]"}]}], "]"}]}], ";", "\n", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", "StLat2", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", 
          RowBox[{"StM", "=", 
           RowBox[{"ReplacePart", "[", 
            RowBox[{"StM", ",", 
             RowBox[{"Last", "[", 
              RowBox[{"StLat2", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
             RowBox[{"First", "[", 
              RowBox[{"StLat2", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "]"}]}]}], "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"ShiftMat", "=", 
         RowBox[{"Function", "[", 
          RowBox[{"y", ",", 
           RowBox[{"Module", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"S", ",", "j", ",", "G"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"S", "=", "StM"}], ";", 
              RowBox[{"For", "[", 
               RowBox[{
                RowBox[{"j", "=", "1"}], ",", 
                RowBox[{"j", "<=", "sz"}], ",", 
                RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"G", "=", 
                  RowBox[{"Transpose", "[", 
                   RowBox[{"S", ",", 
                    RowBox[{"RotateLeft", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", "sz", "]"}], ",", 
                    RowBox[{"j", "-", "1"}]}], "]"}]}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Length", "[", "G", "]"}], "<=", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"y", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ",", 
                   RowBox[{
                    RowBox[{"S", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"Break", "[", "]"}], ";"}], ",", 
                   RowBox[{"S", "=", 
                    RowBox[{"Transpose", "[", 
                    RowBox[{
                    RowBox[{"Drop", "[", 
                    RowBox[{"G", ",", 
                    RowBox[{"y", "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"RotateLeft", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", "sz", "]"}], ",", 
                    RowBox[{
                    RowBox[{"-", "j"}], "+", "1"}]}], "]"}]}], "]"}]}]}], 
                  "]"}]}]}], "]"}], ";", "S"}]}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Collect", " ", "possible", " ", "pairs", " ", "by", " ", "shifting",
           " ", "indices", " ", "of", " ", "the", " ", "lattice"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"BoundList", "=", 
         RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Array", "[", 
            RowBox[{"List", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"1", "+", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{"Rdm", "/", "Mes"}], "+", "1"}], "]"}], "-", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "Rdm"}], "/", "Mes"}], "-", "1"}], "]"}]}], 
               ",", 
               RowBox[{"{", "sz", "}"}]}], "]"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "Rdm"}], "/", "Mes"}], "-", "1"}], "]"}], ",", 
               RowBox[{"{", "sz", "}"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"sz", "-", "1"}]}], "]"}]}], ";", "\n", 
        RowBox[{"OvHistory", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"OvHistory", ",", 
           RowBox[{"Length", "[", "Ov0", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Ov0", "=", 
         RowBox[{"{", 
          RowBox[{"{", "}"}], "}"}]}], ";", "\n", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"k", "=", "1"}], ",", 
          RowBox[{"k", "\[LessEqual]", 
           RowBox[{"Length", "[", "BoundList", "]"}]}], ",", 
          RowBox[{"k", "++"}], ",", 
          RowBox[{
           RowBox[{"SB", "=", 
            RowBox[{"ShiftMat", "[", 
             RowBox[{"BoundList", "[", 
              RowBox[{"[", "k", "]"}], "]"}], "]"}]}], ";", "\n", 
           RowBox[{"Ov0", "=", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"SB", "==", 
               RowBox[{"{", "}"}]}], ",", "Ov0", ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Ov0", "=", 
                RowBox[{"Union", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"{", "}"}], "}"}], ",", "Ov0", ",", 
                  RowBox[{"Map", "[", 
                   RowBox[{
                    RowBox[{"Function", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}], " ", "||", " ", 
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}]}], ",", 
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", 
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                     "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{"MapThread", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"{", 
                    RowBox[{"SB", ",", 
                    RowBox[{"ShiftMat", "[", 
                    RowBox[{"-", 
                    RowBox[{"BoundList", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
                    "sz"}], "]"}], ",", 
                    RowBox[{"sz", "-", "1"}]}], "]"}]}], "]"}]}], "]"}]}], 
               ";", "\[IndentingNewLine]", 
               RowBox[{"Ov0", "=", 
                RowBox[{"Select", "[", 
                 RowBox[{
                  RowBox[{"Drop", "[", 
                   RowBox[{"Ov0", ",", "1"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Norm", "[", 
                    RowBox[{
                    RowBox[{"Lat", "[", 
                    RowBox[{"N", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}], ",", "2"}], 
                    "]"}], "\[LessEqual]", "Rdm"}], ")"}], "&"}]}], 
                 "]"}]}]}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "OvHistory", "]"}], ">", 
           RowBox[{"Ceiling", "[", 
            RowBox[{"MinPow", "/", "Period"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{"OvTwo", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"OvHistory", "[", 
                RowBox[{"[", 
                 RowBox[{"-", 
                  RowBox[{"Ceiling", "[", 
                   RowBox[{"MinPow", "/", "Period"}], "]"}]}], "]"}], "]"}], 
               "}"}]}], "]"}]}], ";", 
           RowBox[{"Goto", "[", "Jump", "]"}]}]}], "]"}], ";", "\n", 
        RowBox[{"StB", "=", 
         RowBox[{"Union", "[", 
          RowBox[{"Nest", "[", 
           RowBox[{"Gs", ",", "StB", ",", "Period"}], "]"}], "]"}]}], ";", 
        "\n", 
        RowBox[{"StLat2", "=", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"z", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{"1", ",", 
                  RowBox[{"{", "sz", "}"}]}], "]"}], "-", 
                RowBox[{"Map", "[", 
                 RowBox[{"Min", ",", 
                  RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}], "+", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{"Lat", "[", 
                   RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "/", "Mes"}], 
                 "]"}]}], ",", "z"}], "}"}]}], "]"}], ",", "StB"}], "]"}]}], 
        ";", "\n", 
        RowBox[{"StM", "=", 
         RowBox[{"Apply", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", "##"}], "]"}], "&"}], ",", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{"1", ",", 
                RowBox[{"{", "sz", "}"}]}], "]"}], "+", 
              RowBox[{"Map", "[", 
               RowBox[{"Max", ",", 
                RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}], "-", 
              RowBox[{"Map", "[", 
               RowBox[{"Min", ",", 
                RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}]}], ",", 
             "1"}], "]"}]}], "]"}]}], ";", "\n", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", "StLat2", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", 
          RowBox[{"StM", "=", 
           RowBox[{"ReplacePart", "[", 
            RowBox[{"StM", ",", 
             RowBox[{"Last", "[", 
              RowBox[{"StLat2", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
             RowBox[{"First", "[", 
              RowBox[{"StLat2", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "]"}]}]}], "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"ShiftMatB", "=", 
         RowBox[{"Function", "[", 
          RowBox[{"y", ",", 
           RowBox[{"Module", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"S", ",", "j", ",", "G"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"S", "=", "StM"}], ";", 
              RowBox[{"For", "[", 
               RowBox[{
                RowBox[{"j", "=", "1"}], ",", 
                RowBox[{"j", "<=", "sz"}], ",", 
                RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"G", "=", 
                  RowBox[{"Transpose", "[", 
                   RowBox[{"S", ",", 
                    RowBox[{"RotateLeft", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", "sz", "]"}], ",", 
                    RowBox[{"j", "-", "1"}]}], "]"}]}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Length", "[", "G", "]"}], "<=", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"y", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ",", 
                   RowBox[{
                    RowBox[{"S", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"Break", "[", "]"}], ";"}], ",", 
                   RowBox[{"S", "=", 
                    RowBox[{"Transpose", "[", 
                    RowBox[{
                    RowBox[{"Drop", "[", 
                    RowBox[{"G", ",", 
                    RowBox[{"y", "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"RotateLeft", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", "sz", "]"}], ",", 
                    RowBox[{
                    RowBox[{"-", "j"}], "+", "1"}]}], "]"}]}], "]"}]}]}], 
                  "]"}]}]}], "]"}], ";", "S"}]}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Collect", " ", "possible", " ", "pairs", " ", "by", " ", "shifting",
           " ", "indices", " ", "of", " ", "the", " ", "lattice"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"BoundList", "=", 
         RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Array", "[", 
            RowBox[{"List", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"1", "+", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{"Rdm", "/", "Mes"}], "+", "1"}], "]"}], "-", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "Rdm"}], "/", "Mes"}], "-", "1"}], "]"}]}], 
               ",", 
               RowBox[{"{", "sz", "}"}]}], "]"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "Rdm"}], "/", "Mes"}], "-", "1"}], "]"}], ",", 
               RowBox[{"{", "sz", "}"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"sz", "-", "1"}]}], "]"}]}], ";", "\n", 
        RowBox[{"OvTwo", "=", 
         RowBox[{"{", 
          RowBox[{"{", "}"}], "}"}]}], ";", "\n", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"k", "=", "1"}], ",", 
          RowBox[{"k", "\[LessEqual]", 
           RowBox[{"Length", "[", "BoundList", "]"}]}], ",", 
          RowBox[{"k", "++"}], ",", 
          RowBox[{
           RowBox[{"SB", "=", 
            RowBox[{"ShiftMatB", "[", 
             RowBox[{"BoundList", "[", 
              RowBox[{"[", "k", "]"}], "]"}], "]"}]}], ";", "\n", 
           RowBox[{"OvTwo", "=", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"SB", "==", 
               RowBox[{"{", "}"}]}], ",", "OvTwo", ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"OvTwo", "=", 
                RowBox[{"Union", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"{", "}"}], "}"}], ",", "OvTwo", ",", 
                  RowBox[{"Map", "[", 
                   RowBox[{
                    RowBox[{"Function", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}], " ", "||", " ", 
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}]}], ",", 
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", 
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                     "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{"MapThread", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"{", 
                    RowBox[{"SB", ",", 
                    RowBox[{"ShiftMatB", "[", 
                    RowBox[{"-", 
                    RowBox[{"BoundList", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
                    "sz"}], "]"}], ",", 
                    RowBox[{"sz", "-", "1"}]}], "]"}]}], "]"}]}], "]"}]}], 
               ";", "\[IndentingNewLine]", 
               RowBox[{"OvTwo", "=", 
                RowBox[{"Select", "[", 
                 RowBox[{
                  RowBox[{"Drop", "[", 
                   RowBox[{"OvTwo", ",", "1"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Norm", "[", 
                    RowBox[{
                    RowBox[{"Lat", "[", 
                    RowBox[{"N", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}], ",", "2"}], 
                    "]"}], "\[LessEqual]", "Rdm"}], ")"}], "&"}]}], 
                 "]"}]}]}]}], "]"}]}], ";"}]}], "\n", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Label", "[", "Jump", "]"}], ";", "\n", 
        RowBox[{"Print", "[", 
         RowBox[{"rp", ",", "\"\< \>\"", ",", 
          RowBox[{"Length", "[", "OvTwo", "]"}], ",", "\"\< \>\"", ",", 
          RowBox[{"Length", "[", "Ov0", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"rp", "++"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
     "\n", 
     RowBox[{"rt2", "=", 
      RowBox[{"Map", "[", 
       RowBox[{"Lat", ",", "rt1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Ov", "=", 
      RowBox[{"{", 
       RowBox[{"{", "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Collect", " ", "possible", " ", "pairs", " ", "by", " ", "shifting", 
       " ", "indices", " ", "of", " ", "the", " ", "lattice"}], " ", "*)"}], 
     "\n", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", "sz"}], ",", 
       RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BoundList2", "=", 
         RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Array", "[", 
            RowBox[{"List", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"1", "+", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"rt2", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "+", "diam"}], 
                    ")"}], "/", "Mes"}], "+", "1"}], "]"}], "-", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"rt2", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "-", "diam"}], 
                    ")"}], "/", "Mes"}], "-", "1"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", "sz"}], "}"}]}], "]"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"rt2", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "-", "diam"}], 
                   ")"}], "/", "Mes"}], "-", "1"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", "sz"}], "}"}]}], "]"}]}], "]"}], 
           ",", 
           RowBox[{"sz", "-", "1"}]}], "]"}]}], ";", "\n", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"k", "=", "1"}], ",", 
          RowBox[{"k", "\[LessEqual]", 
           RowBox[{"Length", "[", "BoundList2", "]"}]}], ",", 
          RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Ov", "=", 
            RowBox[{"Union", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"{", "}"}], "}"}], ",", "Ov", ",", 
              RowBox[{"Map", "[", 
               RowBox[{
                RowBox[{"Function", "[", 
                 RowBox[{"z", ",", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}], " ", "||", " ", 
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}]}], ",", 
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", 
                    RowBox[{"rt1", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "-", 
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                  "]"}], ",", 
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{"MapThread", "[", 
                   RowBox[{"List", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ShiftMat", "[", 
                    RowBox[{"BoundList2", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"ShiftMat", "[", 
                    RowBox[{"-", 
                    RowBox[{"BoundList2", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
                    "sz"}], "]"}], ",", 
                  RowBox[{"sz", "-", "1"}]}], "]"}]}], "]"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Ov", "=", 
            RowBox[{"Select", "[", 
             RowBox[{
              RowBox[{"Drop", "[", 
               RowBox[{"Ov", ",", "1"}], "]"}], ",", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Norm", "[", 
                  RowBox[{
                   RowBox[{"Lat", "[", 
                    RowBox[{"N", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}], ",", "2"}], 
                  "]"}], "\[LessEqual]", "diam"}], ")"}], "&"}]}], "]"}]}], 
           ";"}]}], "\[IndentingNewLine]", "]"}]}]}], "]"}], ";", "\n", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<# of initial overlaps \>\"", ",", 
       RowBox[{"Length", "[", "Ov", "]"}]}], "]"}], ";", "\n", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Main routine took \>\"", ",", 
       RowBox[{
        RowBox[{"SessionTime", "[", "]"}], "-", "ss0"}], ",", " ", 
       "\"\< seconds\>\""}], "]"}], ";", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{"Overlap", " ", "Inflation", " ", "function"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"Rl1", "=", 
      RowBox[{"Function", "[", 
       RowBox[{"z", ",", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Function", "[", 
             RowBox[{"z1", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"z1", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"Q", ".", 
                  RowBox[{"z", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"z1", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "-", 
                 RowBox[{
                  RowBox[{"z1", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                RowBox[{
                 RowBox[{"z1", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
            RowBox[{"Flatten", "[", 
             RowBox[{
              RowBox[{"Outer", "[", 
               RowBox[{"List", ",", 
                RowBox[{"Rl0", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"First", "[", "z", "]"}], "+", "1"}], "]"}], "]"}],
                 ",", 
                RowBox[{"Rl0", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"Last", "[", "z", "]"}], "+", "1"}], "]"}], "]"}], 
                ",", "1"}], "]"}], ",", "1"}], "]"}], ",", "1"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Norm", "[", 
             RowBox[{
              RowBox[{"Lat", "[", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", "2"}], "]"}], 
            "\[LessEqual]", "diam"}], "&"}]}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Overlap", " ", "algorithm"}], " ", "*)"}], "\n", 
     RowBox[{"Inf", "=", 
      RowBox[{"Function", "[", 
       RowBox[{"z", ",", 
        RowBox[{"Union", "[", 
         RowBox[{"Join", "[", 
          RowBox[{"z", ",", 
           RowBox[{"Flatten", "[", 
            RowBox[{
             RowBox[{"Map", "[", 
              RowBox[{"Rl1", ",", "z"}], "]"}], ",", "1"}], "]"}]}], "]"}], 
         "]"}]}], "]"}]}], ";", "\n", 
     RowBox[{"Ov1", "=", 
      RowBox[{"NestWhile", "[", 
       RowBox[{"Inf", ",", "Ov", ",", "UnsameQ", ",", "All"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<# of stable overlaps under inflation: \>\"", ",", 
       RowBox[{"Length", "[", "Ov1", "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Overlap", " ", "graph"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Og", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"z", ",", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Function", "[", 
               RowBox[{"x", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"z", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", "x"}], "}"}]}], "]"}],
               ",", 
              RowBox[{"z", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
          RowBox[{"MapThread", "[", 
           RowBox[{"List", ",", 
            RowBox[{"{", 
             RowBox[{"Ov1", ",", 
              RowBox[{"Map", "[", 
               RowBox[{"Rl1", ",", "Ov1"}], "]"}]}], "}"}]}], "]"}]}], "]"}], 
        ",", "1"}], "]"}]}], ";", "\n", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Construct", " ", "and", " ", "draw", " ", "the", " ", "graph"}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Ov2", "=", 
      RowBox[{"Union", "[", 
       RowBox[{"Flatten", "[", 
        RowBox[{"Og", ",", "1"}], "]"}], "]"}]}], ";", "\n", 
     RowBox[{"gr0", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{"Function", "[", 
         RowBox[{"z", ",", 
          RowBox[{
           RowBox[{"z", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
           RowBox[{"z", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ",", 
        RowBox[{"MapThread", "[", 
         RowBox[{"List", ",", 
          RowBox[{"{", 
           RowBox[{"Ov2", ",", 
            RowBox[{"Range", "[", 
             RowBox[{"Length", "[", "Ov2", "]"}], "]"}]}], "}"}]}], "]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"g", "=", 
      RowBox[{"FromOrderedPairs", "[", 
       RowBox[{"Og", "/.", "gr0"}], "]"}]}], ";", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Delete", " ", "vertices", " ", "without", " ", "outgoing", " ", 
       "edges"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"LL", "=", "\[Infinity]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "Ov2", "]"}], "<", "LL"}], ",", 
       RowBox[{
        RowBox[{"LL", "=", 
         RowBox[{"Length", "[", "Ov2", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Ov2", "=", 
         RowBox[{"Delete", "[", 
          RowBox[{"Ov2", ",", 
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{"OutDegree", "[", "g", "]"}], ",", "0"}], "]"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"g", "=", 
         RowBox[{"InduceSubgraph", "[", 
          RowBox[{"g", ",", 
           RowBox[{"Flatten", "[", 
            RowBox[{"Position", "[", 
             RowBox[{
              RowBox[{"OutDegree", "[", "g", "]"}], ",", 
              RowBox[{"_", "?", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"#", ">", "0"}], "&"}], ")"}]}]}], "]"}], "]"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"Length", "[", "Ov2", "]"}], "]"}]}]}], "]"}], ";", "\n", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Size of potential overlap graph : \>\"", ",", 
       RowBox[{"Length", "[", "Ov2", "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "Ov2", "]"}], "<", "100"}], ",", 
         RowBox[{"ShowGraph", "[", 
          RowBox[{"SpringEmbedding", "[", 
           RowBox[{"g", ",", "200", ",", "0.1"}], "]"}], "]"}]}], "]"}], 
       ";"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Pick", " ", "out", " ", "all", " ", "coincidences"}], " ", 
      "*)"}], "\n", 
     RowBox[{"Ci", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "Ov2", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"First", "[", 
            RowBox[{"Ov2", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[Equal]", 
           RowBox[{"Last", "[", 
            RowBox[{"Ov2", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "&&", 
          RowBox[{
           RowBox[{
            RowBox[{"Ov2", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
           RowBox[{"Table", "[", 
            RowBox[{"0", ",", 
             RowBox[{"{", "sz", "}"}]}], "]"}]}]}], ",", 
         RowBox[{"Ci", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"Ci", ",", "i"}], "]"}]}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Ci", "\[Equal]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{
        RowBox[{
        "Print", "[", "\"\<Data Error: Trivial coincidences not found.\>\"", 
         "]"}], ";", 
        RowBox[{"Interrupt", "[", "]"}], ";"}]}], "]"}], ";", "\n", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Vertices", " ", "which", " ", "do", " ", "not", " ", "lead", " ", "to",
        " ", "a", " ", 
       RowBox[{"coincidence", "."}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Bd", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Tg", "=", 
      RowBox[{"ToAdjacencyMatrix", "[", 
       RowBox[{"TransitiveClosure", "[", "g", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Much", " ", "faster", " ", "than", " ", "using", " ", "shortest", " ", 
       "path", " ", "function"}], " ", "*)"}], "\n", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "1"}], ",", 
       RowBox[{"j", "\[LessEqual]", 
        RowBox[{"Length", "[", "Ov2", "]"}]}], ",", 
       RowBox[{"j", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Max", "[", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Tg", "[", 
               RowBox[{"[", 
                RowBox[{"j", ",", "#"}], "]"}], "]"}], "&"}], ",", "Ci"}], 
            "]"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"Bd", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"Bd", ",", "j"}], "]"}]}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Delete", " ", "coincidences", " ", "which", " ", "might", " ", 
       "appear", " ", "in", " ", 
       RowBox[{"Bd", ".", " ", "In"}], " ", "practice", " ", "it", " ", 
       "never", " ", 
       RowBox[{"appears", "."}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Bd", "=", 
      RowBox[{"Complement", "[", 
       RowBox[{"Bd", ",", "Ci"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Color used for compuation \>\"", ",", "col"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Return Vector \>\"", ",", "rt1"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<# of overlaps leading to coincidence = \>\"", ",", 
       RowBox[{
        RowBox[{"Length", "[", "Ov2", "]"}], "-", 
        RowBox[{"Length", "[", "Bd", "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<# of non coincidence potential overlaps = \>\"", ",", 
       RowBox[{"Length", "[", "Bd", "]"}]}], "]"}], ";", "\n", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Compare", " ", 
       RowBox[{"spectra", ":", 
        RowBox[{
        "Use", " ", "approximation", " ", "to", " ", "avoid", " ", 
         "algebraic", " ", "computation", " ", "of", " ", "spectra"}]}]}], 
      " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "Bd", "]"}], ">", "0"}], ",", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"\"\<Spectral Radius = \>\"", ",", 
          RowBox[{"Rd1", "=", 
           RowBox[{"Max", "[", 
            RowBox[{"Abs", "[", 
             RowBox[{"Eigenvalues", "[", 
              RowBox[{
               RowBox[{"ToAdjacencyMatrix", "[", "g", "]"}], "//", "N"}], 
              "]"}], "]"}], "]"}]}], ",", "\"\<,  PF eigenvalue = \>\"", ",", 
          RowBox[{"Max", "[", 
           RowBox[{"Abs", "[", 
            RowBox[{"Eg", "//", "N"}], "]"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<Radius of induced graph from non coincidence overlaps = \>\"", 
          ",", 
          RowBox[{"Rd2", "=", 
           RowBox[{"Max", "[", 
            RowBox[{"Abs", "[", 
             RowBox[{"Eigenvalues", "[", 
              RowBox[{
               RowBox[{"ToAdjacencyMatrix", "[", 
                RowBox[{"InduceSubgraph", "[", 
                 RowBox[{"g", ",", "Bd"}], "]"}], "]"}], "//", "N"}], "]"}], 
             "]"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Rd2", "<", "Rd1"}], ",", 
          RowBox[{
           RowBox[{"Print", "[", "\"\<Coincidence\>\"", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<Hausdorff dimension of the boundary w.r.t. weak norm = \>\"",
              ",", 
             RowBox[{
              RowBox[{"sz", " ", 
               RowBox[{
                RowBox[{"Log", "[", "Rd2", "]"}], "/", 
                RowBox[{"Log", "[", "Rd1", "]"}]}]}], "//", "N"}]}], "]"}]}], 
          "\[IndentingNewLine]", ",", 
          RowBox[{"Print", "[", "\"\<No Coincidence \>\"", "]"}]}], "]"}]}], 
       ",", 
       RowBox[{"Print", "[", "\"\<No edge overlap found\>\"", "]"}]}], "]"}], 
     ";"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, 3.476808312215228*^9, {3.476810467341508*^9, 
   3.4768104760936327`*^9}, {3.476810691504703*^9, 3.4768107070717382`*^9}, 
   3.4768555123946238`*^9, {3.476856014598378*^9, 3.476856027735775*^9}, {
   3.476858294946039*^9, 3.476858297204433*^9}, {3.476967859882217*^9, 
   3.4769678835877733`*^9}, {3.476968317190411*^9, 3.4769683258947353`*^9}, {
   3.476968447150278*^9, 3.476968447564068*^9}, {3.4769707738446293`*^9, 
   3.4769707996025553`*^9}, 3.477089304184712*^9, {3.477089963821226*^9, 
   3.477090023987135*^9}, {3.477090119050045*^9, 3.477090150368054*^9}, {
   3.47709020216897*^9, 3.477090206416108*^9}, {3.4770902591048403`*^9, 
   3.477090291608451*^9}, {3.477090399238679*^9, 3.477090465251609*^9}, {
   3.4770905501268*^9, 3.477090559661631*^9}, {3.477090612018401*^9, 
   3.477090735885434*^9}, {3.477090814553059*^9, 3.477090818916932*^9}, {
   3.477091001224908*^9, 3.477091084814866*^9}, {3.4770915902957363`*^9, 
   3.4770917606395617`*^9}, {3.4771095136716833`*^9, 
   3.4771095214669228`*^9}, {3.477109642794795*^9, 3.477109689490555*^9}, {
   3.477109895569553*^9, 3.477109908254321*^9}, {3.4771113552632513`*^9, 
   3.4771113610027857`*^9}, {3.477111641659432*^9, 3.4771116452024317`*^9}, {
   3.477111735749465*^9, 3.477111757266395*^9}, {3.4771119366418047`*^9, 
   3.477112016717514*^9}, {3.477112380315874*^9, 3.477112410808321*^9}, {
   3.4771137566718082`*^9, 3.4771137738259487`*^9}, {3.4771140040904207`*^9, 
   3.477114037301383*^9}, {3.4772071871075687`*^9, 3.477207220004415*^9}, {
   3.477289564549917*^9, 3.477289610557193*^9}, 3.477294766679288*^9, {
   3.477297485918042*^9, 3.477297488770396*^9}, {3.4772975609264727`*^9, 
   3.477297563300296*^9}, 3.477299646946447*^9, {3.477343808156139*^9, 
   3.477343832831038*^9}, {3.4773566355789127`*^9, 3.477356655495257*^9}, {
   3.4773566951549807`*^9, 3.4773566953531723`*^9}, {3.4773705155020237`*^9, 
   3.4773705411119957`*^9}, {3.477370924847599*^9, 3.4773709516025963`*^9}, {
   3.477371033964199*^9, 3.4773710604534903`*^9}, {3.4773711796014023`*^9, 
   3.477371182438929*^9}, {3.48904986450354*^9, 3.489049889428966*^9}, {
   3.489049941603251*^9, 3.489050042472748*^9}, {3.489050284993938*^9, 
   3.489050327353191*^9}, {3.491213296793497*^9, 3.491213305189838*^9}, {
   3.491213645808734*^9, 3.49121366069805*^9}, {3.4912145492716923`*^9, 
   3.491214570897148*^9}, {3.4912442922196913`*^9, 3.4912443061845617`*^9}, {
   3.4912443579896193`*^9, 3.491244367762442*^9}, 3.4912444916799917`*^9, 
   3.491244521822535*^9, {3.4912455458491793`*^9, 3.491245617642865*^9}, 
   3.491245741732451*^9, {3.491245811882277*^9, 3.49124584160415*^9}, 
   3.491246018658517*^9, {3.4912925336941433`*^9, 3.491292620725525*^9}, 
   3.491293153995351*^9, 3.491294217473037*^9, {3.4912942498592787`*^9, 
   3.491294278247426*^9}, {3.4912943261008387`*^9, 3.491294362483781*^9}, 
   3.49129508537778*^9, 3.491295289158585*^9, {3.492330661064749*^9, 
   3.492330736383788*^9}, {3.4923307996209784`*^9, 3.49233080318917*^9}, {
   3.492330874871058*^9, 3.49233089072013*^9}, {3.492330934324232*^9, 
   3.4923309672340527`*^9}, 3.492331012521749*^9, {3.49233106592599*^9, 
   3.492331068802354*^9}, {3.492331113733817*^9, 3.492331181378675*^9}, {
   3.492331214869282*^9, 3.49233124512429*^9}, {3.492331932698062*^9, 
   3.492331935466321*^9}, {3.4925487491519613`*^9, 3.4925487704575167`*^9}, {
   3.492636938393024*^9, 3.492636960295354*^9}, {3.503272193375*^9, 
   3.503272220359375*^9}, {3.50345087665625*^9, 3.50345088128125*^9}, {
   3.503450936328125*^9, 3.5034509630625*^9}, {3.522063818875*^9, 
   3.52206389971875*^9}, {3.52206395390625*^9, 3.522063969421875*^9}, {
   3.522064031703125*^9, 3.522064036140625*^9}, {3.522064076921875*^9, 
   3.52206428609375*^9}, {3.52206432203125*^9, 3.5220645635*^9}, {
   3.522064594859375*^9, 3.52206468378125*^9}, {3.5220647513125*^9, 
   3.5220647998125*^9}, 3.522065096921875*^9, {3.52209306265625*^9, 
   3.522093192453125*^9}, {3.522093258234375*^9, 3.522093342078125*^9}, {
   3.5220933878125*^9, 3.52209338978125*^9}, {3.52209342225*^9, 
   3.522093475140625*^9}, {3.52209351590625*^9, 3.5220935401875*^9}, {
   3.522093576140625*^9, 3.522093583078125*^9}, {3.52209361384375*^9, 
   3.522093621796875*^9}, {3.522093655484375*^9, 3.522093680609375*^9}, {
   3.524464762015625*^9, 3.524464805609375*^9}, {3.5244651205625*^9, 
   3.52446531090625*^9}, {3.524465352015625*^9, 3.524465373953125*^9}, {
   3.5244654085625*^9, 3.524465448296875*^9}, 3.524465503578125*^9, {
   3.524466109609375*^9, 3.5244661921875*^9}, {3.524466226125*^9, 
   3.52446625925*^9}, {3.524466290015625*^9, 3.524466295375*^9}, {
   3.524466326109375*^9, 3.52446636103125*^9}, {3.524466402171875*^9, 
   3.524466445828125*^9}, {3.524466508640625*^9, 3.524466526296875*^9}, {
   3.5244666850625*^9, 3.524466688765625*^9}, {3.524467361078125*^9, 
   3.524467366125*^9}, {3.5244674834375*^9, 3.52446748603125*^9}, {
   3.5244679335625*^9, 3.5244679428125*^9}, {3.5244758409375*^9, 
   3.524475958671875*^9}, 3.524476130125*^9, {3.524476288984375*^9, 
   3.524476301296875*^9}, {3.5244765595625*^9, 3.524476593203125*^9}, {
   3.5244767031875*^9, 3.524476730171875*^9}, {3.524477715734375*^9, 
   3.524477835546875*^9}, {3.524477880453125*^9, 3.52447788275*^9}, {
   3.524478042125*^9, 3.5244781141875*^9}, {3.524478184390625*^9, 
   3.524478189703125*^9}, {3.5244783058125*^9, 3.524478321015625*^9}, {
   3.524478483375*^9, 3.524478488515625*^9}, {3.524478535125*^9, 
   3.524478573*^9}, {3.52447862840625*^9, 3.52447864546875*^9}, {
   3.52447870403125*^9, 3.5244787206875*^9}, {3.524478754515625*^9, 
   3.524478841859375*^9}, {3.524478936828125*^9, 3.5244789535*^9}, 
   3.52447912040625*^9, {3.5244791965625*^9, 3.5244791993125*^9}, {
   3.524479896453125*^9, 3.524480072125*^9}, {3.52448259421875*^9, 
   3.524482603921875*^9}, {3.524508450328125*^9, 3.52450848040625*^9}, {
   3.5245085761875*^9, 3.524508592953125*^9}, 3.5324033818125*^9, {
   3.545013701484375*^9, 3.54501380325*^9}, {3.54508779928125*^9, 
   3.545087802578125*^9}, {3.575020030546875*^9, 3.575020054578125*^9}, {
   3.575020086390625*^9, 3.575020241125*^9}, 3.575020276640625*^9, 
   3.575020538875*^9, {3.575020569765625*^9, 3.575020584890625*^9}, {
   3.575020922625*^9, 3.575020932421875*^9}, {3.5750701798065505`*^9, 
   3.5750701801341515`*^9}, {3.5750703366872263`*^9, 3.575070438805005*^9}, {
   3.575070485839088*^9, 3.5750705272259607`*^9}, {3.5750705590188165`*^9, 
   3.5750706069577007`*^9}, {3.5750711038341737`*^9, 
   3.5750711145513926`*^9}, {3.575085437666482*^9, 3.5750854383840837`*^9}, {
   3.5750878248460655`*^9, 3.575087825594867*^9}, {3.575093753602457*^9, 
   3.575093768344483*^9}, {3.57509389769991*^9, 3.575093918182746*^9}, 
   3.602208222591838*^9}]
},
WindowToolbars->"EditBar",
WindowSize->{1016, 706},
WindowMargins->{{434, Automatic}, {Automatic, 53}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
Magnification->1,
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (2011\:5e7410\:670813\
\:65e5)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 12629, 219, 152, "Input"],
Cell[13199, 243, 448, 10, 48, "Message"]
}, Open  ]],
Cell[13662, 256, 103740, 2545, 5812, "Input"]
}
]
*)

(* End of internal cache information *)
