(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     82656,       1814]
NotebookOptionsPosition[     82113,       1792]
NotebookOutlinePosition[     82653,       1814]
CellTagsIndexPosition[     82610,       1811]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{"<<", "Combinatorica`"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"p", "=", "1"}], ";"}], " ", 
  RowBox[{"(*", " ", "Trace", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "=", "1"}], ";"}], " ", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
     "According", " ", "to", " ", "`Determining", " ", "pure", " ", 
      "discrete", " ", "spectrum", " ", "on", " ", "some", " ", "self"}], "-", 
     RowBox[{"affine", " ", 
      RowBox[{"tilings", "'"}], " ", "by", " ", "Akiyama"}], "-", "Lee"}], 
    ",", " ", 
    RowBox[{
     RowBox[{
     "build", " ", "an", " ", "abstract", " ", "form", " ", "of", " ", 
      "cubic", " ", "Pisot", " ", "substitution", " ", "matrix", " ", "whose",
       " ", "\[IndentingNewLine]", "characteristic", " ", "polynomial", " ", 
      "of", " ", "the", " ", "form", " ", 
      RowBox[{"x", "^", "3"}]}], "-", 
     RowBox[{"px", "^", "2"}], "-", "qx", "-", 
     RowBox[{
     "r", "\[IndentingNewLine]", " ", "where", " ", "p", " ", "and", " ", "r",
       " ", "are", " ", 
      RowBox[{"fixed", ".", " ", "Then"}], " ", "q", " ", "is", " ", "in", 
      " ", "the", " ", "interval", " ", "Br", " ", 
      RowBox[{"below", "."}]}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Max", "[", 
      RowBox[{
       RowBox[{"2", "-", "p", "-", "r"}], ",", 
       RowBox[{
        RowBox[{"r", "^", "2"}], "-", 
        RowBox[{
         RowBox[{"Sign", "[", "r", "]"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"p", " ", "r"}]}], ")"}]}], "+", "1"}]}], "]"}], "<=", 
     RowBox[{"p", "+", "r"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Br", "=", 
     RowBox[{"Interval", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Max", "[", 
         RowBox[{
          RowBox[{"2", "-", "p", "-", "r"}], ",", 
          RowBox[{
           RowBox[{"r", "^", "2"}], "-", 
           RowBox[{
            RowBox[{"Sign", "[", "r", "]"}], 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"p", " ", "r"}]}], ")"}]}], "+", "1"}]}], "]"}], ",", 
        RowBox[{"p", "+", "r"}]}], "}"}], "]"}]}], ",", 
    RowBox[{"Print", "[", "\"\<No Pisot polynomial exists.\>\"", "]"}]}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "]"}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Characteristic", " ", "matrix", " ", "with", " ", "variable", " ", 
    RowBox[{"x", " ", ":", " ", 
     RowBox[{
     "Here", " ", "we", " ", "have", " ", "to", " ", "choose", " ", "the", 
      " ", "matrix", " ", "whose", " ", "chracteristic", " ", "polynomial", 
      " ", "has", " ", "trace", " ", 
      RowBox[{"p", "."}]}]}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Mt", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x", "-", "1"}], ",", 
        RowBox[{"-", "a"}], ",", 
        RowBox[{"-", "b"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "c"}], ",", "x", ",", 
        RowBox[{"-", "d"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "e"}], ",", 
        RowBox[{"-", "f"}], ",", "x"}], "}"}]}], "}"}]}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Char", "=", 
   RowBox[{"Det", "[", "Mt", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Cf", "=", 
   RowBox[{"CoefficientList", "[", 
    RowBox[{"Char", ",", "x"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"Cf", "[", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}], "]"}]}], "=!=", "p"}], ",", 
    RowBox[{
     RowBox[{"Print", "[", "\"\<Traces do not match.\>\"", " ", "]"}], ";", 
     RowBox[{"Interrupt", "[", "]"}]}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.45464759696875*^9, 3.4546476670625*^9}, {
   3.45464771334375*^9, 3.4546477173125*^9}, {3.4546477731875*^9, 
   3.454647782953125*^9}, 3.45464781959375*^9, {3.45464812659375*^9, 
   3.454648151203125*^9}, {3.454648242390625*^9, 3.454648315765625*^9}, {
   3.454648352234375*^9, 3.454648528578125*^9}, {3.45464863740625*^9, 
   3.454648751640625*^9}, 3.45464895559375*^9, {3.4546490714375*^9, 
   3.45464907275*^9}, {3.4546496735625*^9, 3.45464968221875*^9}, 
   3.454662942234375*^9, 3.454663049765625*^9, {3.454713619671875*^9, 
   3.454713620890625*^9}, {3.454784181703125*^9, 3.454784196265625*^9}, {
   3.454784227484375*^9, 3.454784368671875*^9}, {3.454784413125*^9, 
   3.454784414015625*^9}, {3.454796276203125*^9, 3.45479628921875*^9}, {
   3.475758457040493*^9, 3.47575846111909*^9}, {3.475758610781962*^9, 
   3.4757586169521103`*^9}, {3.475758798627507*^9, 3.47575880141816*^9}, {
   3.475758869504044*^9, 3.475758889440987*^9}, {3.475758924021473*^9, 
   3.475758949352518*^9}, {3.475759007214953*^9, 3.4757590644093122`*^9}, {
   3.475759131314268*^9, 3.475759175310017*^9}, {3.4767998138861713`*^9, 
   3.4767998410871973`*^9}, {3.4768002535658283`*^9, 3.476800289983285*^9}, {
   3.476800332535603*^9, 3.4768003528184347`*^9}, {3.4768003889354277`*^9, 
   3.476800435149364*^9}, {3.476875601817428*^9, 3.4768756036224194`*^9}, {
   3.476875667953071*^9, 3.476875722584241*^9}, {3.476875766463079*^9, 
   3.476875835709003*^9}, {3.476878600529175*^9, 3.476878767830502*^9}, {
   3.476878812206868*^9, 3.4768788337815943`*^9}, {3.476878909696877*^9, 
   3.4768789187900133`*^9}, {3.476878971512916*^9, 3.4768790103788977`*^9}, {
   3.47687906958848*^9, 3.476879071361655*^9}, {3.4768792186475773`*^9, 
   3.476879267059414*^9}, {3.4768795635274763`*^9, 3.476879568875654*^9}, {
   3.476880203978857*^9, 3.47688024940303*^9}, 3.476880295412281*^9, {
   3.476880847729097*^9, 3.476880850498273*^9}, {3.476881570613863*^9, 
   3.4768816238223124`*^9}, {3.476881666343392*^9, 3.4768816747772713`*^9}, 
   3.47688184916523*^9, {3.4768820297874002`*^9, 3.4768820346158133`*^9}, {
   3.476882080627096*^9, 3.476882081777871*^9}, {3.476882150922748*^9, 
   3.476882220471236*^9}, {3.476882307577854*^9, 3.476882320842257*^9}, 
   3.476883756966832*^9, {3.4768838880064287`*^9, 3.476883897623069*^9}, {
   3.4768844816048603`*^9, 3.476884486736443*^9}, 3.476884568525353*^9, {
   3.476884609070751*^9, 3.4768846099398327`*^9}, {3.476884641663525*^9, 
   3.476884642939644*^9}, {3.47688514643548*^9, 3.476885161042385*^9}, {
   3.476885225021987*^9, 3.476885226372568*^9}, {3.476888155684713*^9, 
   3.476888204430585*^9}, {3.476888276694442*^9, 3.476888320643654*^9}, 
   3.476888356910417*^9, {3.4768883929485073`*^9, 3.476888394132023*^9}, {
   3.476941828147929*^9, 3.476941829121776*^9}, {3.476941862941679*^9, 
   3.4769418640988817`*^9}, {3.476941985065732*^9, 3.4769420091129513`*^9}, {
   3.476942083525141*^9, 3.476942084331417*^9}, {3.4769422041808147`*^9, 
   3.4769422170784388`*^9}, {3.476942257090872*^9, 3.4769422717204723`*^9}, {
   3.476942367118573*^9, 3.476942387822585*^9}, {3.476943528042822*^9, 
   3.476943576235745*^9}, {3.476944378126449*^9, 3.476944449216949*^9}, {
   3.476944581318825*^9, 3.476944595678013*^9}, {3.476944638048341*^9, 
   3.476944651240032*^9}, {3.476944681771864*^9, 3.476944813311153*^9}, {
   3.476945049751347*^9, 3.4769450500284367`*^9}, {3.4769453989393263`*^9, 
   3.476945439301465*^9}, {3.476945958243029*^9, 3.476945963570505*^9}, {
   3.476946134034319*^9, 3.476946147880438*^9}, 3.476946214462646*^9, {
   3.476946291837669*^9, 3.476946307187887*^9}, {3.476946362487207*^9, 
   3.476946575407064*^9}, {3.47694664799605*^9, 3.476946682919467*^9}, 
   3.4769467430346746`*^9, {3.476946833263633*^9, 3.476946895036083*^9}, 
   3.476947097374837*^9, {3.476947184000505*^9, 3.47694721864574*^9}, {
   3.476947289265451*^9, 3.476947292875111*^9}, {3.476947345185631*^9, 
   3.476947443128912*^9}, {3.476948108297845*^9, 3.47694811354501*^9}, {
   3.4769690870887403`*^9, 3.476969105199938*^9}, {3.476973030511509*^9, 
   3.476973277301281*^9}, {3.476973407811656*^9, 3.476973420154778*^9}, {
   3.476973546292592*^9, 3.476973549962327*^9}, {3.476973633299416*^9, 
   3.4769736844582987`*^9}, {3.47697464653343*^9, 3.4769748883123493`*^9}, 
   3.4769751299144707`*^9, {3.476975177608386*^9, 3.4769751943604*^9}, {
   3.476975236179968*^9, 3.476975237225916*^9}, {3.476975406084342*^9, 
   3.476975450686924*^9}, {3.495010686623983*^9, 3.495010722791115*^9}, {
   3.4950107722353363`*^9, 3.495010803921156*^9}, {3.495044479577639*^9, 
   3.495044482402014*^9}, 3.4950445125847483`*^9, {3.5017497852062407`*^9, 
   3.501749819721348*^9}, {3.5017510202364807`*^9, 3.501751022664296*^9}, {
   3.56540679431616*^9, 3.565406806078581*^9}, {3.56540861597816*^9, 
   3.5654087495143943`*^9}, 3.566858067178926*^9, {3.6022087189325323`*^9, 
   3.602208719062533*^9}, {3.6022088388927*^9, 3.602208916022808*^9}, {
   3.6022089787628965`*^9, 3.602209055643004*^9}, {3.6022090859430466`*^9, 
   3.6022092947333384`*^9}, {3.6022093366433973`*^9, 
   3.6022094341635337`*^9}, {3.6022094916336145`*^9, 3.602209579113737*^9}, {
   3.602209845054109*^9, 3.6022098455441093`*^9}, {3.6022107976254425`*^9, 
   3.6022108110454617`*^9}, {3.6022108438455076`*^9, 
   3.6022108587955284`*^9}, {3.6022109088155985`*^9, 3.60221099558572*^9}, {
   3.602377711316472*^9, 3.6023777485765247`*^9}, {3.6023778071666064`*^9, 
   3.602377816346619*^9}, {3.6023796067091255`*^9, 3.6023796153191376`*^9}, 
   3.6023798981595335`*^9, {3.602379938839591*^9, 3.6023800138196955`*^9}, {
   3.6023800548897533`*^9, 3.602380083979794*^9}, {3.60238306102901*^9, 
   3.602383109709078*^9}, {3.602383220829233*^9, 3.6023832845193224`*^9}, {
   3.60238336840944*^9, 3.6023833712294436`*^9}, {3.602383410649499*^9, 
   3.6023834772495923`*^9}, 3.6023838293700852`*^9, {3.602383923720217*^9, 
   3.602383930410227*^9}, {3.6023839882603073`*^9, 3.60238399002031*^9}, {
   3.602386459043767*^9, 3.60238647555379*^9}, {3.6023881772965145`*^9, 
   3.6023881844965243`*^9}, 3.6023882814566603`*^9, {3.60267150765625*^9, 
   3.60267151828125*^9}, {3.602672509953125*^9, 3.6026725194375*^9}, {
   3.60415648975*^9, 3.604156508140625*^9}, {3.604158151515625*^9, 
   3.604158155859375*^9}, {3.605864663484375*^9, 3.6058646638125*^9}, {
   3.605864766890625*^9, 3.60586476703125*^9}, {3.605865227546875*^9, 
   3.605865262578125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Make", " ", "the", " ", "list", " ", 
    RowBox[{"`Ans", "'"}], " ", "of", " ", "cubic", " ", "Pisot", " ", 
    "substitution", " ", "matrices", " ", "under", " ", "the", " ", 
    "assumption", " ", "of", " ", "previous", " ", "paragraph"}], " ", "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Using", " ", "symmetry", " ", "of", " ", "parameters"}], ",", 
    " ", 
    RowBox[{
    "one", " ", "may", " ", "make", " ", "smaller", " ", "the", " ", "list", 
     " ", 
     RowBox[{"`Ans", "'"}]}], ",", " ", 
    RowBox[{
     RowBox[{
     "as", " ", "described", " ", "in", " ", "the", " ", "paper", " ", "by", 
      " ", "introducing", " ", "restrictions", " ", "like", " ", "a"}], 
     "\[LessEqual]", 
     RowBox[{"b", " ", "or", " ", "a"}], "\[LessEqual]", 
     RowBox[{
     "c", " ", "depending", " ", "on", " ", "the", " ", "shape", " ", "of", 
      " ", 
      RowBox[{"Mt", ".", " ", "It"}], " ", "is", " ", "not", " ", "done", " ",
       "by", " ", "default"}]}], ",", " ", 
    RowBox[{
    "which", " ", "should", " ", "be", " ", "done", " ", "by", " ", "the", 
     " ", 
     RowBox[{"user", "."}]}]}], " ", "\[IndentingNewLine]", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Ans", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"K", "=", 
     RowBox[{"r", "+", 
      RowBox[{"p", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Max", "[", "Br", "]"}], "+", 
          RowBox[{"Cf", "[", 
           RowBox[{"[", 
            RowBox[{"-", "3"}], "]"}], "]"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"a", "\[Rule]", "0"}], ",", 
           RowBox[{"b", "\[Rule]", "0"}], ",", 
           RowBox[{"c", "\[Rule]", "0"}], ",", 
           RowBox[{"d", "\[Rule]", "0"}], ",", 
           RowBox[{"e", "\[Rule]", "0"}], ",", 
           RowBox[{"f", "\[Rule]", "0"}]}], "}"}]}], ")"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"a", "=", "0"}], ",", 
      RowBox[{"a", "\[LessEqual]", "K"}], ",", 
      RowBox[{"a", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"b", "=", "0"}], ",", 
        RowBox[{"b", "\[LessEqual]", "K"}], ",", 
        RowBox[{"b", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"c", "=", "0"}], ",", 
          RowBox[{"c", "\[LessEqual]", "K"}], ",", 
          RowBox[{"c", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"d", "=", "0"}], ",", 
            RowBox[{"d", "\[LessEqual]", "K"}], ",", 
            RowBox[{"d", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"For", "[", 
             RowBox[{
              RowBox[{"e", "=", "0"}], ",", 
              RowBox[{"e", "\[LessEqual]", "K"}], ",", 
              RowBox[{"e", "++"}], ",", "\[IndentingNewLine]", 
              RowBox[{"For", "[", 
               RowBox[{
                RowBox[{"f", "=", "0"}], ",", 
                RowBox[{"f", "\[LessEqual]", "K"}], ",", 
                RowBox[{"f", "++"}], ",", 
                RowBox[{"If", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"IntervalMemberQ", "[", 
                    RowBox[{"Br", ",", 
                    RowBox[{"-", 
                    RowBox[{"Cf", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], " ", "&&", " ", 
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Cf", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "\[Equal]", "r"}]}], 
                  ",", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Print", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"Mt", "/.", 
                    RowBox[{"x", "\[Rule]", "0"}]}], ")"}]}], "//", 
                    "MatrixForm"}], "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"Ans", "=", 
                    RowBox[{"Append", "[", 
                    RowBox[{"Ans", ",", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"Mt", "/.", 
                    RowBox[{"x", "\[Rule]", "0"}]}], ")"}]}]}], "]"}]}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Print", "[", "Char", "]"}], ";"}]}], 
                 "\[IndentingNewLine]", "]"}]}], "]"}]}], "]"}]}], "]"}]}], 
         "]"}]}], "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<There are \>\"", ",", 
      RowBox[{"Length", "[", "Ans", "]"}], ",", 
      "\"\< substitution matrices to be checked.\>\""}], "]"}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.45464759696875*^9, 3.4546476670625*^9}, {
   3.45464771334375*^9, 3.4546477173125*^9}, {3.4546477731875*^9, 
   3.454647782953125*^9}, 3.45464781959375*^9, {3.45464812659375*^9, 
   3.454648151203125*^9}, {3.454648242390625*^9, 3.454648315765625*^9}, {
   3.454648352234375*^9, 3.454648528578125*^9}, {3.45464863740625*^9, 
   3.454648751640625*^9}, 3.45464895559375*^9, {3.4546490714375*^9, 
   3.45464907275*^9}, {3.4546496735625*^9, 3.45464968221875*^9}, 
   3.454662942234375*^9, 3.454663049765625*^9, {3.454713619671875*^9, 
   3.454713620890625*^9}, {3.454784181703125*^9, 3.454784196265625*^9}, {
   3.454784227484375*^9, 3.454784368671875*^9}, {3.454784413125*^9, 
   3.454784414015625*^9}, {3.454796276203125*^9, 3.45479628921875*^9}, {
   3.475758457040493*^9, 3.47575846111909*^9}, {3.475758610781962*^9, 
   3.4757586169521103`*^9}, {3.475758798627507*^9, 3.47575880141816*^9}, {
   3.475758869504044*^9, 3.475758889440987*^9}, {3.475758924021473*^9, 
   3.475758949352518*^9}, {3.475759007214953*^9, 3.4757590644093122`*^9}, {
   3.475759131314268*^9, 3.475759175310017*^9}, {3.4767998138861713`*^9, 
   3.4767998410871973`*^9}, {3.4768002535658283`*^9, 3.476800289983285*^9}, {
   3.476800332535603*^9, 3.4768003528184347`*^9}, {3.4768003889354277`*^9, 
   3.476800435149364*^9}, {3.476875601817428*^9, 3.4768756036224194`*^9}, {
   3.476875667953071*^9, 3.476875722584241*^9}, {3.476875766463079*^9, 
   3.476875835709003*^9}, {3.476878600529175*^9, 3.476878767830502*^9}, {
   3.476878812206868*^9, 3.4768788337815943`*^9}, {3.476878909696877*^9, 
   3.4768789187900133`*^9}, {3.476878971512916*^9, 3.4768790103788977`*^9}, {
   3.47687906958848*^9, 3.476879071361655*^9}, {3.4768792186475773`*^9, 
   3.476879267059414*^9}, {3.4768795635274763`*^9, 3.476879568875654*^9}, {
   3.476880203978857*^9, 3.47688024940303*^9}, 3.476880295412281*^9, {
   3.476880847729097*^9, 3.476880850498273*^9}, {3.476881570613863*^9, 
   3.4768816238223124`*^9}, {3.476881666343392*^9, 3.4768816747772713`*^9}, 
   3.47688184916523*^9, {3.4768820297874002`*^9, 3.4768820346158133`*^9}, {
   3.476882080627096*^9, 3.476882081777871*^9}, {3.476882150922748*^9, 
   3.476882220471236*^9}, {3.476882307577854*^9, 3.476882320842257*^9}, 
   3.476883756966832*^9, {3.4768838880064287`*^9, 3.476883897623069*^9}, {
   3.4768844816048603`*^9, 3.476884486736443*^9}, 3.476884568525353*^9, {
   3.476884609070751*^9, 3.4768846099398327`*^9}, {3.476884641663525*^9, 
   3.476884642939644*^9}, {3.47688514643548*^9, 3.476885161042385*^9}, {
   3.476885225021987*^9, 3.476885226372568*^9}, {3.476888155684713*^9, 
   3.476888204430585*^9}, {3.476888276694442*^9, 3.476888320643654*^9}, 
   3.476888356910417*^9, {3.4768883929485073`*^9, 3.476888394132023*^9}, {
   3.476941828147929*^9, 3.476941829121776*^9}, {3.476941862941679*^9, 
   3.4769418640988817`*^9}, {3.476941985065732*^9, 3.4769420091129513`*^9}, {
   3.476942083525141*^9, 3.476942084331417*^9}, {3.4769422041808147`*^9, 
   3.4769422170784388`*^9}, {3.476942257090872*^9, 3.4769422717204723`*^9}, {
   3.476942367118573*^9, 3.476942387822585*^9}, {3.476943528042822*^9, 
   3.476943576235745*^9}, {3.476944378126449*^9, 3.476944449216949*^9}, {
   3.476944581318825*^9, 3.476944595678013*^9}, {3.476944638048341*^9, 
   3.476944651240032*^9}, {3.476944681771864*^9, 3.476944813311153*^9}, {
   3.476945049751347*^9, 3.4769450500284367`*^9}, {3.4769453989393263`*^9, 
   3.476945439301465*^9}, {3.476945958243029*^9, 3.476945963570505*^9}, {
   3.476946134034319*^9, 3.476946147880438*^9}, 3.476946214462646*^9, {
   3.476946291837669*^9, 3.476946307187887*^9}, {3.476946362487207*^9, 
   3.476946575407064*^9}, {3.47694664799605*^9, 3.476946682919467*^9}, 
   3.4769467430346746`*^9, {3.476946833263633*^9, 3.476946895036083*^9}, 
   3.476947097374837*^9, {3.476947184000505*^9, 3.47694721864574*^9}, {
   3.476947289265451*^9, 3.476947292875111*^9}, {3.476947345185631*^9, 
   3.476947443128912*^9}, {3.476948108297845*^9, 3.47694811354501*^9}, {
   3.4769690870887403`*^9, 3.476969105199938*^9}, {3.476973030511509*^9, 
   3.476973277301281*^9}, {3.476973407811656*^9, 3.476973420154778*^9}, {
   3.476973546292592*^9, 3.476973549962327*^9}, {3.476973633299416*^9, 
   3.4769736844582987`*^9}, {3.47697464653343*^9, 3.4769748883123493`*^9}, 
   3.4769751299144707`*^9, {3.476975177608386*^9, 3.4769751943604*^9}, {
   3.476975236179968*^9, 3.476975237225916*^9}, {3.476975406084342*^9, 
   3.476975450686924*^9}, {3.495010826739175*^9, 3.495010828782865*^9}, {
   3.495044784277013*^9, 3.4950448097676764`*^9}, {3.501750009251904*^9, 
   3.5017500332294197`*^9}, 3.5017504158386297`*^9, {3.6022095866437473`*^9, 
   3.6022096969939017`*^9}, {3.602210229154647*^9, 3.6022102432546663`*^9}, {
   3.602210278594716*^9, 3.6022102999547462`*^9}, 3.6022110461657906`*^9, {
   3.6023801457398806`*^9, 3.602380149889886*^9}, {3.602380320480125*^9, 
   3.60238040250024*^9}, {3.602383138659118*^9, 3.602383200229204*^9}, {
   3.602383586659745*^9, 3.6023835971497602`*^9}, {3.6024127057168036`*^9, 
   3.6024127061230536`*^9}, {3.6024135938418036`*^9, 
   3.6024135943105536`*^9}, {3.602671558515625*^9, 3.602671558859375*^9}, {
   3.60301313265625*^9, 3.60301313309375*^9}, {3.604156528609375*^9, 
   3.60415653153125*^9}, {3.605865075703125*^9, 3.605865176296875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Check", " ", "coincidences", " ", "of", " ", "substitutions", " ", 
    "whose", " ", "substitution", " ", "matrix", " ", "is", " ", "in", " ", 
    "the", " ", "list", " ", "`Ans`"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "If", " ", "there", " ", "are", " ", "more", " ", "than", " ", "10000", 
     " ", "potential", " ", "overlaps"}], ",", " ", 
    RowBox[{
    "then", " ", "we", " ", "postpone", " ", "the", " ", "substitution", " ", 
     "and", " ", "put", " ", "it", " ", "aside", " ", "in", " ", "the", " ", 
     "homework", " ", "list", " ", 
     RowBox[{
      RowBox[{"`Sk", "'"}], ".", " ", "\[IndentingNewLine]", "By"}], " ", 
     "this", " ", "bound", " ", "10000"}], ",", " ", 
    RowBox[{
     RowBox[{
     "all", " ", "the", " ", "computation", " ", "in", " ", "the", " ", 
      "paper", " ", "by", " ", "Akiyama"}], "-", 
     RowBox[{"Lee", " ", "are", " ", "finished", " ", "at", " ", "a", " ", 
      RowBox[{"time", ".", " ", "However"}], " ", "this", " ", "computation", 
      " ", "requires", " ", "large", " ", "memory", " ", "and", " ", "it", 
      " ", "may", " ", "be", " ", "too", " ", "large", " ", "for", " ", "a", 
      " ", "personal", " ", 
      RowBox[{"computer", ".", " ", "\[IndentingNewLine]", "If"}], " ", 
      "excessive", " ", "harddisk", " ", "access", " ", "happens"}]}], ",", 
    " ", 
    RowBox[{
    "then", " ", "make", " ", "the", " ", "value", " ", "smaller", " ", 
     "like", " ", "5000.", " ", "This", " ", "description", " ", "is", " ", 
     "found", " ", "in", " ", "the", " ", "last", " ", "part", " ", "of", " ",
      "the", " ", 
     RowBox[{"program", ":", " ", 
      RowBox[{"`If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "Ov2", "]"}], ">", "10000"}], ",", " ", 
        RowBox[{"...", "'"}]}], " ", "\[IndentingNewLine]"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Cum", "=", "0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Sk", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"k0", "=", "1"}], ",", 
      RowBox[{"k0", "\[LessEqual]", 
       RowBox[{"Length", "[", "Ans", "]"}]}], ",", 
      RowBox[{"k0", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"w", "=", "\"\<0\>\""}], ";", "\n", 
       RowBox[{"Ans1", "=", 
        RowBox[{"{", "}"}]}], ";", "\n", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"s", "=", "1"}], ",", 
         RowBox[{"s", "\[LessEqual]", "3"}], ",", 
         RowBox[{"s", "++"}], ",", "\n", 
         RowBox[{
          RowBox[{"L0", "=", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"Ans", "[", 
              RowBox[{"[", "k0", "]"}], "]"}], "]"}], "[", 
            RowBox[{"[", "s", "]"}], "]"}]}], ";", "\n", 
          RowBox[{"L1", "=", 
           RowBox[{"{", "}"}]}], ";", "\n", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "1"}], ",", 
            RowBox[{"i", "\[LessEqual]", 
             RowBox[{"Length", "[", "L0", "]"}]}], ",", 
            RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"L1", "=", 
             RowBox[{"Join", "[", 
              RowBox[{"L1", ",", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"FromCharacterCode", "[", 
                  RowBox[{"i", "+", "47"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"L0", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "}"}]}], "]"}]}], 
              "]"}]}]}], "]"}], ";", "\n", 
          RowBox[{"Rl0", "=", 
           RowBox[{"{", "}"}]}], ";", "\n", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "1"}], ",", 
            RowBox[{"i", "\[LessEqual]", 
             RowBox[{"Length", "[", "L1", "]"}]}], ",", 
            RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Rl0", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"Rl0", ",", 
               RowBox[{"i", "\[Rule]", 
                RowBox[{"L1", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}]}], "]"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Ans1", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"Ans1", ",", "\[IndentingNewLine]", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{"Function", "[", 
                RowBox[{"z", ",", 
                 RowBox[{
                  RowBox[{"FromCharacterCode", "[", 
                   RowBox[{"s", "+", "47"}], "]"}], "->", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Fold", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"#1", "<>", "#2"}], "&"}], ",", "\"\<\>\"", ",", 
                    "z"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Union", "[", 
                RowBox[{
                 RowBox[{"Permutations", "[", 
                  RowBox[{"Length", "[", "L1", "]"}], "]"}], "/.", "Rl0"}], 
                "]"}]}], "]"}]}], "]"}]}]}]}], "]"}], ";", "\n", 
       RowBox[{"Ans3", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Outer", "[", 
           RowBox[{"List", ",", 
            RowBox[{"Ans1", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"Ans1", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{"Ans1", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}], "]"}], ",", "2"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Symmetric", " ", "substitution", " ", "are", " ", "not", " ", 
         "necessary"}], " ", "*)"}], " ", "\[IndentingNewLine]", 
       RowBox[{"Ans3", "=", 
        RowBox[{"Extract", "[", 
         RowBox[{"Ans3", ",", 
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Map", "[", 
             RowBox[{"First", ",", 
              RowBox[{"Union", "[", 
               RowBox[{"Map", "[", 
                RowBox[{"Sort", ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"i", ",", 
                    RowBox[{"First", "[", 
                    RowBox[{"First", "[", 
                    RowBox[{"Position", "[", 
                    RowBox[{"Ans3", ",", 
                    RowBox[{"Map", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
                    RowBox[{"StringReverse", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ")"}], "&"}], 
                    ",", 
                    RowBox[{"Ans3", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
                    "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"Length", "[", "Ans3", "]"}]}], "}"}]}], "]"}]}], 
                "]"}], "]"}]}], "]"}], ",", "1"}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"k0", ",", "\"\<-th matrix\>\"", ",", 
         RowBox[{"Ans", "[", 
          RowBox[{"[", "k0", "]"}], "]"}], ",", "\"\< \>\"", ",", 
         RowBox[{"Length", "[", "Ans3", "]"}], ",", 
         "\"\< substitutions\>\""}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Cum", "=", 
        RowBox[{"Cum", "+", 
         RowBox[{"Length", "[", "Ans3", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"I0", "=", "1"}], ",", 
         RowBox[{"I0", "\[LessEqual]", 
          RowBox[{"Length", "[", "Ans3", "]"}]}], ",", 
         RowBox[{"I0", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rl", "=", 
           RowBox[{"Ans3", "[", 
            RowBox[{"[", "I0", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{"I0", ",", "\"\< \>\"", ",", "Rl"}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Tb", "=", 
           RowBox[{"Flatten", "[", 
            RowBox[{"Map", "[", 
             RowBox[{"ToCharacterCode", ",", 
              RowBox[{"Map", "[", 
               RowBox[{"First", ",", "Rl"}], "]"}]}], "]"}], "]"}]}], ";", 
          "\n", 
          RowBox[{"ToSt", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"x", ",", 
             RowBox[{"FromCharacterCode", "[", 
              RowBox[{"Tb", "[", 
               RowBox[{"[", 
                RowBox[{"x", "+", "1"}], "]"}], "]"}], "]"}]}], "]"}]}], ";", 
          "\n", 
          RowBox[{"k", "=", 
           RowBox[{"Length", "[", "Rl", "]"}]}], ";", "\n", 
          RowBox[{"A1", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{"StringPosition", "[", 
                  RowBox[{"#1", ",", 
                   RowBox[{"ToSt", "[", "i", "]"}]}], "]"}], "]"}], "&"}], 
               ")"}], "/@", 
              RowBox[{"Last", "/@", "Rl"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", 
               RowBox[{"k", "-", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
          RowBox[{"TL", "=", 
           RowBox[{"First", "[", 
            RowBox[{"Last", "[", 
             RowBox[{"Eigensystem", "[", 
              RowBox[{"Transpose", "[", "A1", "]"}], "]"}], "]"}], "]"}]}], 
          ";", "\n", 
          RowBox[{"Eg", "=", 
           RowBox[{"Sort", "[", 
            RowBox[{
             RowBox[{"Eigenvalues", "[", "A1", "]"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"N", "[", 
                RowBox[{"Abs", "[", "#1", "]"}], "]"}], "<=", 
               RowBox[{"N", "[", 
                RowBox[{"Abs", "[", "#2", "]"}], "]"}]}], "&"}]}], "]"}]}], 
          ";", "\n", 
          RowBox[{"Flist", "=", 
           RowBox[{"First", "/@", 
            RowBox[{"FactorList", "[", 
             RowBox[{"CharacteristicPolynomial", "[", 
              RowBox[{"A1", ",", "x"}], "]"}], "]"}]}]}], ";", "\n", 
          RowBox[{"Flist", "=", 
           RowBox[{"Delete", "[", 
            RowBox[{"Flist", ",", 
             RowBox[{"Position", "[", 
              RowBox[{
               RowBox[{"NumberQ", "/@", "Flist"}], ",", "True"}], "]"}]}], 
            "]"}]}], ";", 
          RowBox[{"FlistSol", "=", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Max", "[", 
               RowBox[{"Abs", "[", "#1", "]"}], "]"}], "&"}], ")"}], "/@", 
            RowBox[{"(", 
             RowBox[{"x", "/.", "\[InvisibleSpace]", 
              RowBox[{
               RowBox[{"Function", "[", 
                RowBox[{"z", ",", 
                 RowBox[{"Solve", "[", 
                  RowBox[{"z", ",", "x"}], "]"}]}], "]"}], "/@", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"#1", "\[Equal]", "0"}], "&"}], ")"}], "/@", 
                "Flist"}]}]}], ")"}]}]}], ";", "\n", 
          RowBox[{"Fd", "=", 
           RowBox[{"First", "[", 
            RowBox[{"Extract", "[", 
             RowBox[{"Flist", ",", 
              RowBox[{"Position", "[", 
               RowBox[{"FlistSol", ",", 
                RowBox[{"Max", "[", "FlistSol", "]"}]}], "]"}]}], "]"}], 
            "]"}]}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{"Show", "[", 
            RowBox[{
             RowBox[{"Graphics", "[", 
              RowBox[{"Circle", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", "1"}], "]"}], "]"}], 
             ",", 
             RowBox[{"Graphics", "/@", 
              RowBox[{"Point", "/@", 
               RowBox[{"FullSimplify", "[", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Re", "[", "#1", "]"}], ",", 
                    RowBox[{"Im", "[", "#1", "]"}]}], "}"}], "&"}], ")"}], "/@",
                  "Eg"}], "]"}]}]}], ",", 
             RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}], " ", 
           "*)"}], "\n", 
          RowBox[{"Eg0", "=", 
           RowBox[{"Sort", "[", 
            RowBox[{
             RowBox[{"x", "/.", "\[InvisibleSpace]", 
              RowBox[{"NSolve", "[", 
               RowBox[{
                RowBox[{"Fd", "\[Equal]", "0"}], ",", "x"}], "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"N", "[", 
                RowBox[{"Abs", "[", "#1", "]"}], "]"}], "<", 
               RowBox[{"N", "[", 
                RowBox[{"Abs", "[", "#2", "]"}], "]"}]}], "&"}]}], "]"}]}], 
          ";", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "Eg0", "]"}], "<", 
             RowBox[{"Length", "[", "Eg", "]"}]}], ",", 
            RowBox[{
            "Print", "[", "\"\<Reducible characteristic polynomial\>\"", 
             "]"}]}], "]"}], ";", "\n", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Choose", " ", "some", " ", "power", " ", "of", " ", 
             "substitution", " ", "to", " ", "obtain", " ", "a", " ", "fixed",
              " ", "letter"}], ",", " ", 
            RowBox[{"i", ".", "e", "."}], ",", " ", 
            RowBox[{
            "to", " ", "make", " ", "the", " ", "trace", " ", "of", " ", 
             "the", " ", "incidence", " ", "matrix", " ", "positive"}]}], " ",
            "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Rp", "=", "1"}], ";", "\[IndentingNewLine]", 
          RowBox[{"While", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"Fold", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"#1", "+", "#2"}], "&"}], ",", "0", ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"StringCount", "[", 
                  RowBox[{
                   RowBox[{"Nest", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"#", ",", "Rl"}], "]"}], "&"}], ",", 
                    RowBox[{"ToSt", "[", "i", "]"}], ",", "Rp"}], "]"}], ",", 
                   RowBox[{"ToSt", "[", "i", "]"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "0", ",", 
                   RowBox[{
                    RowBox[{"Length", "[", "Rl", "]"}], "-", "1"}]}], "}"}]}],
                 "]"}]}], "]"}], "\[Equal]", "0"}], "\[IndentingNewLine]", 
            ",", 
            RowBox[{"Rp", "++"}]}], "]"}], ";", "\n", 
          RowBox[{"Rl", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"ToSt", "[", "i", "]"}], "->", 
              RowBox[{"Nest", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"StringReplace", "[", 
                  RowBox[{"#", ",", "Rl"}], "]"}], "&"}], ",", 
                RowBox[{"ToSt", "[", "i", "]"}], ",", "Rp"}], "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", 
               RowBox[{
                RowBox[{"Length", "[", "Rl", "]"}], "-", "1"}]}], "}"}]}], 
            "]"}]}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"Print", "[", "Rl", "]"}], ";"}], "*)"}], "\n", 
          RowBox[{"wpos", "=", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"#", "\[Equal]", 
                 RowBox[{"{", "}"}]}], ",", "$MaxMachineNumber", ",", 
                RowBox[{"First", "[", 
                 RowBox[{"First", "[", "#", "]"}], "]"}]}], "]"}], "&"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"StringPosition", "[", 
                RowBox[{
                 RowBox[{"StringReplace", "[", 
                  RowBox[{
                   RowBox[{"ToSt", "[", "i", "]"}], ",", "Rl"}], "]"}], ",", 
                 RowBox[{"ToSt", "[", "i", "]"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "0", ",", 
                 RowBox[{
                  RowBox[{"Length", "[", "Rl", "]"}], "-", "1"}]}], "}"}]}], 
              "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"w", "=", 
           RowBox[{"ToSt", "[", 
            RowBox[{
             RowBox[{"First", "[", 
              RowBox[{"Position", "[", 
               RowBox[{"wpos", ",", 
                RowBox[{"Min", "[", "wpos", "]"}]}], "]"}], "]"}], "-", "1"}],
             "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{"\"\<Use a fix letter \>\"", ",", "w"}], "]"}], ";"}], 
           " ", "*)"}], "\n", 
          RowBox[{"k", "=", 
           RowBox[{"Length", "[", "Rl", "]"}]}], ";", "\n", 
          RowBox[{"A1", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{"StringPosition", "[", 
                  RowBox[{"#1", ",", 
                   RowBox[{"ToSt", "[", "i", "]"}]}], "]"}], "]"}], "&"}], 
               ")"}], "/@", 
              RowBox[{"Last", "/@", "Rl"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", 
               RowBox[{"k", "-", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
          RowBox[{"TL", "=", 
           RowBox[{"First", "[", 
            RowBox[{"Last", "[", 
             RowBox[{"Eigensystem", "[", 
              RowBox[{"Transpose", "[", "A1", "]"}], "]"}], "]"}], "]"}]}], 
          ";", "\n", 
          RowBox[{"Eg", "=", 
           RowBox[{"Sort", "[", 
            RowBox[{
             RowBox[{"Eigenvalues", "[", "A1", "]"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"N", "[", 
                RowBox[{"Abs", "[", "#1", "]"}], "]"}], "<=", 
               RowBox[{"N", "[", 
                RowBox[{"Abs", "[", "#2", "]"}], "]"}]}], "&"}]}], "]"}]}], 
          ";", "\n", 
          RowBox[{"Flist", "=", 
           RowBox[{"First", "/@", 
            RowBox[{"FactorList", "[", 
             RowBox[{"CharacteristicPolynomial", "[", 
              RowBox[{"A1", ",", "x"}], "]"}], "]"}]}]}], ";", "\n", 
          RowBox[{"Flist", "=", 
           RowBox[{"Delete", "[", 
            RowBox[{"Flist", ",", 
             RowBox[{"Position", "[", 
              RowBox[{
               RowBox[{"NumberQ", "/@", "Flist"}], ",", "True"}], "]"}]}], 
            "]"}]}], ";", 
          RowBox[{"FlistSol", "=", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Max", "[", 
               RowBox[{"Abs", "[", "#1", "]"}], "]"}], "&"}], ")"}], "/@", 
            RowBox[{"(", 
             RowBox[{"x", "/.", "\[InvisibleSpace]", 
              RowBox[{
               RowBox[{"Function", "[", 
                RowBox[{"z", ",", 
                 RowBox[{"Solve", "[", 
                  RowBox[{"z", ",", "x"}], "]"}]}], "]"}], "/@", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"#1", "\[Equal]", "0"}], "&"}], ")"}], "/@", 
                "Flist"}]}]}], ")"}]}]}], ";", "\n", 
          RowBox[{"Fd", "=", 
           RowBox[{"First", "[", 
            RowBox[{"Extract", "[", 
             RowBox[{"Flist", ",", 
              RowBox[{"Position", "[", 
               RowBox[{"FlistSol", ",", 
                RowBox[{"Max", "[", "FlistSol", "]"}]}], "]"}]}], "]"}], 
            "]"}]}], ";", "\n", 
          RowBox[{"AlgSol", "=", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"AlgebraicNumber", "[", 
               RowBox[{
                RowBox[{"Root", "[", 
                 RowBox[{"Fd", ",", "#1"}], "]"}], ",", 
                RowBox[{"PadRight", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"0", ",", "1"}], "}"}], ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{"CoefficientList", "[", 
                    RowBox[{"Fd", ",", "x"}], "]"}], "]"}]}], "]"}]}], "]"}], 
              "&"}], ")"}], "/@", 
            RowBox[{"Range", "[", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"CoefficientList", "[", 
                RowBox[{"Fd", ",", "x"}], "]"}], "]"}], "-", "1"}], "]"}]}]}],
           ";", "\n", 
          RowBox[{"Rep", "=", 
           RowBox[{
            RowBox[{"Last", "[", "Eg", "]"}], "\[Rule]", 
            RowBox[{"ToNumberField", "[", 
             RowBox[{
              RowBox[{"Last", "[", "Eg", "]"}], ",", 
              RowBox[{"Root", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Fd", "/.", "\[InvisibleSpace]", 
                  RowBox[{"x", "\[Rule]", "#1"}]}], "&"}], ",", 
                RowBox[{"First", "[", 
                 RowBox[{"First", "[", 
                  RowBox[{"Position", "[", 
                   RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"AlgSol", "//", "N"}], "]"}], ",", 
                    RowBox[{"Max", "[", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"AlgSol", "//", "N"}], "]"}], "]"}]}], "]"}], 
                  "]"}], "]"}]}], "]"}]}], "]"}]}]}], ";", "\n", 
          RowBox[{"TL0", "=", 
           RowBox[{
            RowBox[{"Function", "[", 
             RowBox[{"z", ",", 
              RowBox[{"ToNumberField", "[", 
               RowBox[{"z", ",", 
                RowBox[{"Root", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Fd", "/.", "\[InvisibleSpace]", 
                    RowBox[{"x", "\[Rule]", "#1"}]}], "&"}], ",", 
                  RowBox[{"First", "[", 
                   RowBox[{"First", "[", 
                    RowBox[{"Position", "[", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{"AlgSol", "//", "N"}], "]"}], ",", 
                    RowBox[{"Max", "[", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"AlgSol", "//", "N"}], "]"}], "]"}]}], "]"}], 
                    "]"}], "]"}]}], "]"}]}], "]"}]}], "]"}], "/@", "TL"}]}], 
          ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{"\"\<Tile Length = \>\"", ",", "TL0"}], "]"}], ";"}], 
           " ", "*)"}], "\n", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Fold", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"#1", "+", "#2"}], "&"}], ",", "0", ",", 
               RowBox[{"Abs", "[", 
                RowBox[{"N", "[", 
                 RowBox[{"TL", "-", "TL0"}], "]"}], "]"}]}], "]"}], ">", 
             RowBox[{"$MachineEpsilon", " ", 
              RowBox[{"10", "^", "7"}]}]}], ",", 
            RowBox[{
             RowBox[{
             "Print", "[", "\"\<Algebraic Number association error\>\"", 
              "]"}], ";", 
             RowBox[{"Abort", "[", "]"}]}], ",", 
            RowBox[{
             RowBox[{"TL", "=", "TL0"}], ";"}]}], "]"}], ";", "\n", 
          RowBox[{"diam", "=", 
           RowBox[{"Max", "[", "TL", "]"}]}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Find", " ", "a", " ", "prefix", " ", "with", " ", "2", "nd", " ", 
            "occurence", " ", "of", " ", "w"}], " ", "*)"}], "\n", 
          RowBox[{"w0", "=", 
           RowBox[{"NestWhile", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"StringReplace", "[", 
               RowBox[{"#", ",", "Rl"}], "]"}], "&"}], ",", "w", ",", 
             RowBox[{
              RowBox[{"!", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Length", "[", 
                  RowBox[{"StringPosition", "[", 
                   RowBox[{"#1", ",", "w"}], "]"}], "]"}], ">", "1"}], 
                ")"}]}], "&"}]}], "]"}]}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{"Compute", " ", "the", " ", "return", " ", "word"}], " ", 
           "*)"}], "\n", 
          RowBox[{"rt0", "=", 
           RowBox[{"StringDrop", "[", 
            RowBox[{
             RowBox[{"StringTake", "[", 
              RowBox[{"w0", ",", 
               RowBox[{"Map", "[", 
                RowBox[{"First", ",", 
                 RowBox[{"StringPosition", "[", 
                  RowBox[{"w0", ",", "w", ",", "2"}], "]"}]}], "]"}]}], "]"}],
              ",", 
             RowBox[{"-", "1"}]}], "]"}]}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{
             "\"\<Return word of \>\"", ",", "w", ",", "\"\< is \>\"", ",", 
              "rt0"}], "]"}], ";"}], "*)"}], "\n", 
          RowBox[{"(*", " ", 
           RowBox[{"Return", " ", "tile", " ", "length"}], " ", "*)"}], "\n", 
          RowBox[{"al", "=", 
           RowBox[{"TL", ".", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"StringCount", "[", 
               RowBox[{"rt0", ",", 
                RowBox[{"ToSt", "[", "i", "]"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "0", ",", 
                RowBox[{"k", "-", "1"}]}], "}"}]}], "]"}]}]}], ";", "\n", 
          RowBox[{"Q", "=", 
           RowBox[{"Last", "[", 
            RowBox[{"Eg", "/.", "Rep"}], "]"}]}], ";", "\n", 
          RowBox[{"C0", "=", 
           RowBox[{"diam", "+", 
            RowBox[{"al", "/", "Q"}]}]}], ";", " ", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{"Geometric", " ", "substitution", " ", "data"}], " ", 
           "*)"}], "\n", 
          RowBox[{"Rl0", "=", 
           RowBox[{"{", "}"}]}], ";", "\n", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "0"}], ",", 
            RowBox[{"i", "\[LessEqual]", 
             RowBox[{"k", "-", "1"}]}], ",", 
            RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"St", "=", 
              RowBox[{"{", "}"}]}], ";", 
             RowBox[{"L00", "=", "0"}], ";", 
             RowBox[{"Tes", "=", 
              RowBox[{
               RowBox[{"ToSt", "[", "i", "]"}], "/.", "Rl"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"For", "[", 
              RowBox[{
               RowBox[{"j", "=", "1"}], ",", 
               RowBox[{"j", "\[LessEqual]", 
                RowBox[{"StringLength", "[", "Tes", "]"}]}], ",", 
               RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"St", "=", 
                 RowBox[{"Append", "[", 
                  RowBox[{"St", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"First", "[", 
                    RowBox[{"Position", "[", 
                    RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{"First", ",", "Rl"}], "]"}], ",", 
                    RowBox[{"StringTake", "[", 
                    RowBox[{"Tes", ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "j"}], "}"}]}], "]"}]}], "]"}], "]"}], 
                    "]"}], "-", "1"}], ",", "L00"}], "}"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"L00", "=", 
                 RowBox[{"L00", "+", 
                  RowBox[{"TL", "[", 
                   RowBox[{"[", 
                    RowBox[{"First", "[", 
                    RowBox[{"First", "[", 
                    RowBox[{"Position", "[", 
                    RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{"First", ",", "Rl"}], "]"}], ",", 
                    RowBox[{"StringTake", "[", 
                    RowBox[{"Tes", ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "j"}], "}"}]}], "]"}]}], "]"}], "]"}], 
                    "]"}], "]"}], "]"}]}]}], ";"}]}], "\[IndentingNewLine]", 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Rl0", "=", 
              RowBox[{"Append", "[", 
               RowBox[{"Rl0", ",", "St"}], "]"}]}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{"Geometric", " ", "substitution"}], " ", "*)"}], "\n", 
          RowBox[{"Gsbst", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"z", ",", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"#", "+", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", 
                   RowBox[{"Q", " ", 
                    RowBox[{"Last", "[", "z", "]"}]}]}], "}"}]}], "&"}], ",", 
               RowBox[{"Rl0", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"First", "[", "z", "]"}], "+", "1"}], "]"}], 
                "]"}]}], "]"}]}], "]"}]}], ";", "\n", 
          RowBox[{"Gs", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"z", ",", 
             RowBox[{"Flatten", "[", 
              RowBox[{
               RowBox[{"Map", "[", 
                RowBox[{"Gsbst", ",", "z"}], "]"}], ",", "1"}], "]"}]}], 
            "]"}]}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Execute", " ", "Lemma", " ", "3.5", " ", "and", " ", "3.6", " ", 
            "on", " ", "the", " ", "paper", " ", "of", " ", 
            "\"\<Algorithm for determining pure pointedness\nof self-affine \
tilings\>\""}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"OvTwo1", "=", 
           RowBox[{"{", "}"}]}], ";", "\n", 
          RowBox[{"OvTwo", "=", 
           RowBox[{"{", "\[Infinity]", "}"}]}], ";", "\n", 
          RowBox[{"rp", "=", "0"}], ";", "\n", 
          RowBox[{"St1", "=", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}], "}"}]}], ";", " ", "\n", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Last", "[", 
              RowBox[{"Last", "[", "St1", "]"}], "]"}], "<", "C0"}], ",", 
            RowBox[{"St1", "=", 
             RowBox[{"Gs", "[", "St1", "]"}]}]}], "]"}], ";", "\n", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "OvTwo1", "]"}], "<", 
             RowBox[{"Length", "[", "OvTwo", "]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"OvTwo1", "=", "OvTwo"}], ";", "\[IndentingNewLine]", 
             RowBox[{"OvTwo", "=", 
              RowBox[{"Union", "[", 
               RowBox[{"Select", "[", 
                RowBox[{
                 RowBox[{"Partition", "[", 
                  RowBox[{
                   RowBox[{"Flatten", "[", 
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{
                    RowBox[{"Function", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", 
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"MapThread", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Drop", "[", 
                    RowBox[{"St1", ",", "i"}], "]"}], ",", 
                    RowBox[{"Drop", "[", 
                    RowBox[{"St1", ",", 
                    RowBox[{"-", "i"}]}], "]"}]}], "}"}], ",", "1"}], "]"}], 
                    ",", "1"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", 
                    RowBox[{"-", 
                    RowBox[{"Min", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Floor", "[", 
                    RowBox[{"C0", "/", 
                    RowBox[{"Min", "[", "TL", "]"}]}], "]"}], "+", "1"}], ",", 
                    RowBox[{
                    RowBox[{"Length", "[", "St1", "]"}], "-", "1"}]}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Min", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Floor", "[", 
                    RowBox[{"C0", "/", 
                    RowBox[{"Min", "[", "TL", "]"}]}], "]"}], "+", "1"}], ",", 
                    RowBox[{
                    RowBox[{"Length", "[", "St1", "]"}], "-", "1"}]}], 
                    "]"}]}], "}"}]}], "]"}], "]"}], ",", "3"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "C0"}], "<=", 
                   RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[LessEqual]", "C0"}], 
                  "&"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"Print", "[", 
                RowBox[{"rp", ",", "\"\< \>\"", ",", 
                 RowBox[{"Length", "[", "OvTwo", "]"}]}], "]"}], ";"}], 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"rp", "++"}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Length", "[", "OvTwo1", "]"}], "<", 
                RowBox[{"Length", "[", "OvTwo", "]"}]}], ",", 
               RowBox[{"St1", "=", 
                RowBox[{"Gs", "[", "St1", "]"}]}]}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\n", 
          RowBox[{"Ov", "=", 
           RowBox[{"Union", "[", 
            RowBox[{"Select", "[", 
             RowBox[{
              RowBox[{"Partition", "[", 
               RowBox[{
                RowBox[{"Flatten", "[", 
                 RowBox[{"Table", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Map", "[", 
                    RowBox[{
                    RowBox[{"Function", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "al", "-", 
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"MapThread", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Drop", "[", 
                    RowBox[{"St1", ",", "i"}], "]"}], ",", 
                    RowBox[{"Drop", "[", 
                    RowBox[{"St1", ",", 
                    RowBox[{"-", "i"}]}], "]"}]}], "}"}], ",", "1"}], "]"}], 
                    ",", "1"}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", 
                    RowBox[{
                    RowBox[{"Ceiling", "[", 
                    RowBox[{"al", "/", 
                    RowBox[{"Max", "[", "TL", "]"}]}], "]"}], "-", "1"}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{"Min", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Floor", "[", 
                    RowBox[{"al", "/", 
                    RowBox[{"Min", "[", "TL", "]"}]}], "]"}], "+", "1"}], ",", 
                    RowBox[{
                    RowBox[{"Length", "[", "St1", "]"}], "-", "1"}]}], 
                    "]"}]}], "}"}]}], "]"}], "]"}], ",", "3"}], "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "diam"}], "<=", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "<=", "diam"}], "&"}]}], 
             "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{"\"\<# of initial overlaps \>\"", ",", 
              RowBox[{"Length", "[", "Ov", "]"}]}], "]"}], ";"}], "*)"}], 
          "\n", 
          RowBox[{"(*", " ", 
           RowBox[{"Overlap", " ", "Inflation", " ", "function"}], " ", 
           "*)"}], " ", "\n", 
          RowBox[{"Rl1", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"z", ",", 
             RowBox[{"Select", "[", 
              RowBox[{
               RowBox[{"Map", "[", 
                RowBox[{
                 RowBox[{"Function", "[", 
                  RowBox[{"z1", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"z1", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Q", " ", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "+", " ", 
                    RowBox[{
                    RowBox[{"z1", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"z1", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"z1", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
                 RowBox[{"Flatten", "[", 
                  RowBox[{
                   RowBox[{"Outer", "[", 
                    RowBox[{"List", ",", " ", 
                    RowBox[{"Rl0", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"First", "[", "z", "]"}], "+", "1"}], "]"}], 
                    "]"}], ",", 
                    RowBox[{"Rl0", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"Last", "[", "z", "]"}], "+", "1"}], "]"}], "]"}],
                     ",", "1"}], "]"}], ",", "1"}], "]"}], ",", "1"}], "]"}], 
               ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "diam"}], "<=", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "<=", "diam"}], "&"}]}], 
              "]"}]}], "]"}]}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{"Overlap", " ", "algorithm"}], " ", "*)"}], "\n", 
          RowBox[{"Inf", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"z", ",", 
             RowBox[{"Union", "[", 
              RowBox[{"Join", "[", 
               RowBox[{"z", ",", 
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{"Map", "[", 
                   RowBox[{"Rl1", ",", "z"}], "]"}], ",", "1"}], "]"}]}], 
               "]"}], "]"}]}], "]"}]}], ";", "\n", 
          RowBox[{"Ov1", " ", "=", " ", 
           RowBox[{"NestWhile", "[", 
            RowBox[{
            "Inf", ",", " ", "Ov", ",", " ", "UnsameQ", ",", " ", "All"}], 
            "]"}]}], ";", 
          StyleBox["\[IndentingNewLine]", "Text"], 
          RowBox[{"(*", " ", 
           RowBox[{"Overlap", " ", "graph"}], " ", "*)"}], "\n", 
          RowBox[{"Og", "=", 
           RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{"Function", "[", 
                RowBox[{"z", ",", 
                 RowBox[{"Map", "[", 
                  RowBox[{
                   RowBox[{"Function", "[", 
                    RowBox[{"x", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "x"}], "}"}]}], 
                    "]"}], ",", 
                   RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
               RowBox[{"MapThread", "[", 
                RowBox[{"List", ",", 
                 RowBox[{"{", 
                  RowBox[{"Ov1", ",", 
                   RowBox[{"Map", "[", 
                    RowBox[{"Rl1", ",", "Ov1"}], "]"}]}], "}"}]}], "]"}]}], 
              "]"}], ",", "1"}], "]"}]}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Construct", " ", "and", " ", "draw", " ", "the", " ", "graph"}], 
           " ", "*)"}], "\n", 
          RowBox[{"Ov2", "=", 
           RowBox[{"Union", "[", 
            RowBox[{"Flatten", "[", 
             RowBox[{"Og", ",", "1"}], "]"}], "]"}]}], ";", "\n", 
          RowBox[{"gr0", "=", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{"Function", "[", 
              RowBox[{"z", ",", 
               RowBox[{
                RowBox[{"z", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
                RowBox[{"z", "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ",", 
             RowBox[{"MapThread", "[", 
              RowBox[{"List", ",", 
               RowBox[{"{", 
                RowBox[{"Ov2", ",", 
                 RowBox[{"Range", "[", 
                  RowBox[{"Length", "[", "Ov2", "]"}], "]"}]}], "}"}]}], 
              "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"g", "=", 
           RowBox[{"FromOrderedPairs", "[", 
            RowBox[{"Og", "/.", "gr0"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Delete", " ", "vertices", " ", "without", " ", "outgoing", " ", 
            "edges"}], " ", "*)"}], "\n", 
          RowBox[{"LL", "=", "\[Infinity]"}], ";", "\n", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "Ov2", "]"}], "<", "LL"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"LL", "=", 
              RowBox[{"Length", "[", "Ov2", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Ov2", "=", 
              RowBox[{"Delete", "[", 
               RowBox[{"Ov2", ",", 
                RowBox[{"Position", "[", 
                 RowBox[{
                  RowBox[{"OutDegree", "[", "g", "]"}], ",", "0"}], "]"}]}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"g", "=", 
              RowBox[{"InduceSubgraph", "[", 
               RowBox[{"g", ",", 
                RowBox[{"Flatten", "[", 
                 RowBox[{"Position", "[", 
                  RowBox[{
                   RowBox[{"OutDegree", "[", "g", "]"}], ",", 
                   RowBox[{"_", "?", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", ">", "0"}], "&"}], ")"}]}]}], "]"}], "]"}]}],
                "]"}]}], ";"}]}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"Print", "[", 
             RowBox[{"Length", "[", "Ov2", "]"}], "]"}], "*)"}], 
           "\[IndentingNewLine]", "]"}], ";", "\n", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{"\"\<Size of potential overlap graph : \>\"", ",", " ", 
              RowBox[{"Length", "[", "Ov2", "]"}]}], "]"}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "Ov2", "]"}], ">", "10000"}], ",", 
            RowBox[{
             RowBox[{
             "Print", "[", 
              "\"\<Postpone this substitution having a large graph.\>\"", 
              "]"}], ";", 
             RowBox[{"Sk", "=", 
              RowBox[{"Append", "[", 
               RowBox[{"Sk", ",", "Rl"}], "]"}]}], ";", 
             RowBox[{"Goto", "[", "Jump", "]"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"Pick", " ", "out", " ", "all", " ", "coincidences"}], " ",
            "*)"}], "\n", 
          RowBox[{"Ci", "=", 
           RowBox[{"{", "}"}]}], ";", "\n", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "1"}], ",", 
            RowBox[{"i", "\[LessEqual]", 
             RowBox[{"Length", "[", "Ov2", "]"}]}], ",", 
            RowBox[{"i", "++"}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"First", "[", 
                 RowBox[{"Ov2", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[Equal]", 
                RowBox[{"Last", "[", 
                 RowBox[{"Ov2", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}]}], " ", "&&", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"Ov2", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}]}], ",", 
              RowBox[{"Ci", "=", 
               RowBox[{"Append", "[", 
                RowBox[{"Ci", ",", "i"}], "]"}]}]}], "]"}]}], "]"}], ";", 
          "\n", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"Ci", "\[Equal]", 
             RowBox[{"{", "}"}]}], ",", 
            RowBox[{
             RowBox[{
             "Print", "[", 
              "\"\<Data Error: Trivial coincidences not found.\>\"", "]"}], 
             ";", 
             RowBox[{"Interrupt", "[", "]"}], ";"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Vertices", " ", "which", " ", "does", " ", "not", " ", "leads", 
            " ", "to", " ", "a", " ", 
            RowBox[{"coincidence", "."}]}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"Bd", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Tg", "=", 
           RowBox[{"ToAdjacencyMatrix", "[", 
            RowBox[{"TransitiveClosure", "[", "g", "]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Much", " ", "faster", " ", "than", " ", "using", " ", "shortest", 
            " ", "path", " ", "function"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", "=", "1"}], ",", 
            RowBox[{"j", "\[LessEqual]", 
             RowBox[{"Length", "[", "Ov2", "]"}]}], ",", 
            RowBox[{"j", "++"}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Max", "[", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Tg", "[", 
                    RowBox[{"[", 
                    RowBox[{"j", ",", "#"}], "]"}], "]"}], "&"}], ",", "Ci"}],
                  "]"}], "]"}], "\[Equal]", "0"}], ",", 
              RowBox[{"Bd", "=", 
               RowBox[{"Append", "[", 
                RowBox[{"Bd", ",", "j"}], "]"}]}]}], "]"}]}], "]"}], ";", 
          "\n", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"Ci", "==", 
             RowBox[{"{", "}"}]}], ",", 
            RowBox[{"Bd", "=", 
             RowBox[{"Range", "[", 
              RowBox[{"Length", "[", "Ov2", "]"}], "]"}]}]}], "]"}], ";", " ",
           "\[IndentingNewLine]", 
          RowBox[{"Bd", "=", 
           RowBox[{"Complement", "[", 
            RowBox[{"Bd", ",", "Ci"}], "]"}]}], ";", "\n", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{
             "\"\<# of overlaps leading to coincidence = \>\"", ",", " ", 
              RowBox[{
               RowBox[{"Length", "[", "Ov2", "]"}], "-", 
               RowBox[{"Length", "[", "Bd", "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Print", "[", 
             RowBox[{"\"\<# of non coincidence overlaps = \>\"", ",", 
              RowBox[{"Length", "[", "Bd", "]"}]}], "]"}], ";"}], " ", "*)"}],
           "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"Compare", " ", 
            RowBox[{"spectra", " ", ":", " ", 
             RowBox[{
             "Use", " ", "approximation", " ", "to", " ", "avoid", " ", 
              "algebraic", " ", "computation", " ", "of", " ", 
              "spectra"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "Bd", "]"}], ">", "0"}], ",", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"\"\<Spectral Radius = \>\"", ",", 
               RowBox[{"Rd1", "=", 
                RowBox[{"Max", "[", 
                 RowBox[{"Abs", "[", 
                  RowBox[{"Eigenvalues", "[", 
                   RowBox[{
                    RowBox[{"ToAdjacencyMatrix", "[", "g", "]"}], "//", "N"}],
                    "]"}], "]"}], "]"}]}], ",", " ", 
               "\"\<,  PF eigenvalue =\>\"", ",", 
               RowBox[{"Q", "//", "N"}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Print", "[", 
              RowBox[{
              "\"\<Radius of induced graph from non coincidence overlaps = \>\
\"", ",", 
               RowBox[{"Rd2", "=", 
                RowBox[{"Max", "[", 
                 RowBox[{"Abs", "[", 
                  RowBox[{"Eigenvalues", "[", 
                   RowBox[{
                    RowBox[{"ToAdjacencyMatrix", "[", 
                    RowBox[{"InduceSubgraph", "[", 
                    RowBox[{"g", ",", "Bd"}], "]"}], "]"}], "//", "N"}], 
                   "]"}], "]"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Rd2", "<", "Rd1"}], ",", 
               RowBox[{"Print", "[", "\"\<Coincidence\>\"", "]"}], ",", 
               RowBox[{
                RowBox[{"Print", "[", "\"\<No Coincidence \>\"", "]"}], ";", 
                RowBox[{"Interrupt", "[", "]"}], ";"}]}], "]"}]}], ",", 
            RowBox[{"Print", "[", "\"\<No edge overlap found\>\"", "]"}]}], 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Label", "[", "Jump", "]"}], ";"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"Cum", ",", "\"\< substitutions are finished\>\""}], "]"}], 
       ";", " ", "\[IndentingNewLine]", 
       RowBox[{"Save", "[", 
        RowBox[{"\"\<Kekka\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"k0", ",", "Sk"}], "}"}]}], "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<We postponed \>\"", ",", 
      RowBox[{"Length", "[", "Sk", "]"}], ",", 
      "\"\< substitutions whose overlap graphs are too large.\>\""}], "]"}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.45464759696875*^9, 3.4546476670625*^9}, {
   3.45464771334375*^9, 3.4546477173125*^9}, {3.4546477731875*^9, 
   3.454647782953125*^9}, 3.45464781959375*^9, {3.45464812659375*^9, 
   3.454648151203125*^9}, {3.454648242390625*^9, 3.454648315765625*^9}, {
   3.454648352234375*^9, 3.454648528578125*^9}, {3.45464863740625*^9, 
   3.454648751640625*^9}, 3.45464895559375*^9, {3.4546490714375*^9, 
   3.45464907275*^9}, {3.4546496735625*^9, 3.45464968221875*^9}, 
   3.454662942234375*^9, 3.454663049765625*^9, {3.454713619671875*^9, 
   3.454713620890625*^9}, {3.454784181703125*^9, 3.454784196265625*^9}, {
   3.454784227484375*^9, 3.454784368671875*^9}, {3.454784413125*^9, 
   3.454784414015625*^9}, {3.454796276203125*^9, 3.45479628921875*^9}, {
   3.475758457040493*^9, 3.47575846111909*^9}, {3.475758610781962*^9, 
   3.4757586169521103`*^9}, {3.475758798627507*^9, 3.47575880141816*^9}, {
   3.475758869504044*^9, 3.475758889440987*^9}, {3.475758924021473*^9, 
   3.475758949352518*^9}, {3.475759007214953*^9, 3.4757590644093122`*^9}, {
   3.475759131314268*^9, 3.475759175310017*^9}, {3.4767998138861713`*^9, 
   3.4767998410871973`*^9}, {3.4768002535658283`*^9, 3.476800289983285*^9}, {
   3.476800332535603*^9, 3.4768003528184347`*^9}, {3.4768003889354277`*^9, 
   3.476800435149364*^9}, {3.476875601817428*^9, 3.4768756036224194`*^9}, {
   3.476875667953071*^9, 3.476875722584241*^9}, {3.476875766463079*^9, 
   3.476875835709003*^9}, {3.476878600529175*^9, 3.476878767830502*^9}, {
   3.476878812206868*^9, 3.4768788337815943`*^9}, {3.476878909696877*^9, 
   3.4768789187900133`*^9}, {3.476878971512916*^9, 3.4768790103788977`*^9}, {
   3.47687906958848*^9, 3.476879071361655*^9}, {3.4768792186475773`*^9, 
   3.476879267059414*^9}, {3.4768795635274763`*^9, 3.476879568875654*^9}, {
   3.476880203978857*^9, 3.47688024940303*^9}, 3.476880295412281*^9, {
   3.476880847729097*^9, 3.476880850498273*^9}, {3.476881570613863*^9, 
   3.4768816238223124`*^9}, {3.476881666343392*^9, 3.4768816747772713`*^9}, 
   3.47688184916523*^9, {3.4768820297874002`*^9, 3.4768820346158133`*^9}, {
   3.476882080627096*^9, 3.476882081777871*^9}, {3.476882150922748*^9, 
   3.476882220471236*^9}, {3.476882307577854*^9, 3.476882320842257*^9}, 
   3.476883756966832*^9, {3.4768838880064287`*^9, 3.476883897623069*^9}, {
   3.4768844816048603`*^9, 3.476884486736443*^9}, 3.476884568525353*^9, {
   3.476884609070751*^9, 3.4768846099398327`*^9}, {3.476884641663525*^9, 
   3.476884642939644*^9}, {3.47688514643548*^9, 3.476885161042385*^9}, {
   3.476885225021987*^9, 3.476885226372568*^9}, {3.476888155684713*^9, 
   3.476888204430585*^9}, {3.476888276694442*^9, 3.476888320643654*^9}, 
   3.476888356910417*^9, {3.4768883929485073`*^9, 3.476888394132023*^9}, {
   3.476941828147929*^9, 3.476941829121776*^9}, {3.476941862941679*^9, 
   3.4769418640988817`*^9}, {3.476941985065732*^9, 3.4769420091129513`*^9}, {
   3.476942083525141*^9, 3.476942084331417*^9}, {3.4769422041808147`*^9, 
   3.4769422170784388`*^9}, {3.476942257090872*^9, 3.4769422717204723`*^9}, {
   3.476942367118573*^9, 3.476942387822585*^9}, {3.476943528042822*^9, 
   3.476943576235745*^9}, {3.476944378126449*^9, 3.476944449216949*^9}, {
   3.476944581318825*^9, 3.476944595678013*^9}, {3.476944638048341*^9, 
   3.476944651240032*^9}, {3.476944681771864*^9, 3.476944813311153*^9}, {
   3.476945049751347*^9, 3.4769450500284367`*^9}, {3.4769453989393263`*^9, 
   3.476945439301465*^9}, {3.476945958243029*^9, 3.476945963570505*^9}, {
   3.476946134034319*^9, 3.476946147880438*^9}, 3.476946214462646*^9, {
   3.476946291837669*^9, 3.476946307187887*^9}, {3.476946362487207*^9, 
   3.476946575407064*^9}, {3.47694664799605*^9, 3.476946682919467*^9}, 
   3.4769467430346746`*^9, {3.476946833263633*^9, 3.476946895036083*^9}, 
   3.476947097374837*^9, {3.476947184000505*^9, 3.47694721864574*^9}, {
   3.476947289265451*^9, 3.476947292875111*^9}, {3.476947345185631*^9, 
   3.476947443128912*^9}, {3.476948108297845*^9, 3.47694811354501*^9}, {
   3.4769690870887403`*^9, 3.476969105199938*^9}, {3.476973030511509*^9, 
   3.476973277301281*^9}, {3.476973407811656*^9, 3.476973420154778*^9}, {
   3.476973546292592*^9, 3.476973549962327*^9}, {3.476973633299416*^9, 
   3.4769736844582987`*^9}, {3.47697464653343*^9, 3.4769748883123493`*^9}, 
   3.4769751299144707`*^9, {3.476975177608386*^9, 3.4769751943604*^9}, {
   3.476975236179968*^9, 3.476975237225916*^9}, {3.476975406084342*^9, 
   3.476975450686924*^9}, {3.495011134379046*^9, 3.495011153988592*^9}, {
   3.495011253944284*^9, 3.495011259988349*^9}, {3.495011726781292*^9, 
   3.4950117347937202`*^9}, {3.501750521201557*^9, 3.50175055211259*^9}, {
   3.501750587435321*^9, 3.501750590503487*^9}, {3.5017506592643433`*^9, 
   3.501750690383004*^9}, {3.501750808832161*^9, 3.5017508229770927`*^9}, {
   3.501750884538752*^9, 3.501750958739706*^9}, {3.565406863034281*^9, 
   3.5654069729052734`*^9}, {3.565407011031741*^9, 3.565407053354615*^9}, {
   3.5654071012466993`*^9, 3.565407102947102*^9}, {3.565407180292038*^9, 
   3.5654071862824483`*^9}, {3.5654073126582704`*^9, 
   3.5654073165738773`*^9}, {3.5654073953852158`*^9, 
   3.5654076137855997`*^9}, {3.5654076787285137`*^9, 3.565407681832919*^9}, {
   3.5654077868367033`*^9, 3.565407885070076*^9}, {3.56540939621353*^9, 
   3.565409445603217*^9}, {3.565411487667695*^9, 3.5654115432349925`*^9}, {
   3.565411656974792*^9, 3.565411673323621*^9}, {3.566779545379428*^9, 
   3.5667796431264353`*^9}, {3.5667797684586587`*^9, 3.566779801843584*^9}, {
   3.566779890310658*^9, 3.5667799632837358`*^9}, 3.5667800092965674`*^9, {
   3.566858093932973*^9, 3.5668580950717745`*^9}, {3.602209768004001*^9, 
   3.6022097683540015`*^9}, {3.6022098973541822`*^9, 3.602209925174221*^9}, {
   3.6022106458252296`*^9, 3.602210661545252*^9}, {3.6022107061953144`*^9, 
   3.602210706645315*^9}, {3.602210754215382*^9, 3.60221076021539*^9}, {
   3.602377684576435*^9, 3.6023776894364414`*^9}, {3.602377884136714*^9, 
   3.602377884856715*^9}, {3.6023779205467653`*^9, 3.602377970636835*^9}, {
   3.602379654039192*^9, 3.602379655449194*^9}, {3.602386745394168*^9, 
   3.6023868907443714`*^9}, {3.602386935604434*^9, 3.6023869496544533`*^9}, {
   3.602387008004535*^9, 3.602387059114607*^9}, {3.6023882011465473`*^9, 
   3.6023882024765496`*^9}, {3.6023883895568113`*^9, 
   3.6023884549569035`*^9}, {3.602388496426961*^9, 3.602388517746991*^9}, 
   3.6023886123571234`*^9, {3.602389162027893*^9, 3.602389191907935*^9}, {
   3.602412748419928*^9, 3.602412749763678*^9}, {3.6024137044355536`*^9, 
   3.602413712294928*^9}, {3.6024138079355536`*^9, 3.602413808544928*^9}, {
   3.602671383296875*^9, 3.60267139090625*^9}, {3.6026714548125*^9, 
   3.60267147659375*^9}, {3.602671744921875*^9, 3.602671745390625*^9}, {
   3.6026718063125*^9, 3.60267181175*^9}, {3.602671862734375*^9, 
   3.6026718685625*^9}, {3.602671933953125*^9, 3.602671938953125*^9}, {
   3.602672883625*^9, 3.60267288771875*^9}, {3.60271088790625*^9, 
   3.602710900859375*^9}, 3.602711065140625*^9, {3.602744229709421*^9, 
   3.6027442669466867`*^9}, {3.60415670321875*^9, 3.60415670365625*^9}, {
   3.6041567540625*^9, 3.604156754421875*^9}, {3.6041568151875*^9, 
   3.604156815375*^9}, 3.6041575303125*^9, {3.605864700328125*^9, 
   3.60586471015625*^9}, {3.605864787359375*^9, 3.60586478784375*^9}, {
   3.605864897984375*^9, 3.605864949234375*^9}, {3.605865011359375*^9, 
   3.6058650119375*^9}, {3.60586529715625*^9, 3.605865298640625*^9}, 
   3.6058653430625*^9, {3.6088520101301966`*^9, 3.6088520196902103`*^9}}]
},
WindowToolbars->{},
WindowSize->{1006, 734},
WindowMargins->{{-3, Automatic}, {Automatic, 2}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
Magnification->1,
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (2011\:5e7410\:670813\
\:65e5)",
StyleDefinitions->"Default.nb",
PrivateNotebookOptions -> {
 "VersionedStylesheet" -> {"Default.nb"[8.] -> False}}
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 10525, 202, 312, "Input"],
Cell[11073, 224, 10337, 197, 392, "Input"],
Cell[21413, 423, 60696, 1367, 3452, "Input"]
}
]
*)

(* End of internal cache information *)
